var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import store from "../store/store";
import { loadUrlConfig } from "./loadUrlConfig";
import * as selector from "../selector";
import * as consts from "../actions/const";
var CWSURI;
var CPDFURI;
var baseURI;
var webpdfURI;
var serverUrlConfig = {
    "appStoreApiUrl": "https://appstore-fz04.foxitsoftware.com",
    cReaderEnable: false,
    casApiUrl: "https://cas-fz04.connectedpdf.com",
    cloudApiUrl: "https://cloud-fz04.connectedpdf.com",
    cpdfdocApiUrl: "https://beta-fz04.connectedpdf.com",
    cwsApiUrl: "https://cws-fz04.connectedpdf.com",
    webpdfApiUrl: "https://cpdfwebviewer-fz04.connectedpdf.com/webpdf",
};
window.phantomOnlineGlobalConfig = serverUrlConfig;
console.log(serverUrlConfig);
CWSURI = serverUrlConfig.cwsApiUrl;
CPDFURI = serverUrlConfig.cpdfdocApiUrl;
baseURI = serverUrlConfig.cloudApiUrl;
webpdfURI = serverUrlConfig.webpdfApiUrl;
export function getToken() {
    var accessToken = "5c04c4abc2dc97e3fe00f9cf%2Cwenqi_zheng%40foxitsoftware.com";
    store.dispatch({ type: consts.save_token, accessToken: accessToken });
    return accessToken;
}
export function setUserInfo(accessToken) {
    return __awaiter(this, void 0, void 0, function () {
        var userInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getUser(accessToken)];
                case 1:
                    userInfo = _a.sent();
                    store.dispatch({ type: consts.save_user, userInfo: userInfo });
                    return [2 /*return*/];
            }
        });
    });
}
export function getUser(accessToken) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        cache: false,
                        url: baseURI + '/api/auth/get_user_info?access-token=' + accessToken,
                        success: function (response) {
                            if (response.ret == 0 || response.ret == "0") {
                                var userInfo = response.data;
                                userInfo.accessToken = accessToken;
                                window.sessionStorage.setItem('userInfo', JSON.stringify(userInfo));
                                return resolve(userInfo);
                            }
                            else {
                                reject(response.message);
                            }
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
/*获取 url  get 请求参数*/
export function getQueryVariable(variable) {
    var query = window.location.search.substring(1);
    var vars = query.split('&');
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split('=');
        if (pair[0] === variable) {
            return pair[1];
        }
    }
    return false;
}
/**
 * 函数功能简述
 * 退出登录
 *
 * @param    {object}    service     cas需要的service
 * @param    {function}  callback    退出登录成功之后
 * @returns  void
 */
export function logoutFn(service, callback) {
    if (!service) {
        window.sessionStorage.setItem('pathname', '');
        service = encodeURIComponent(window.location.protocol + "//" + window.location.host + window.location.search);
    }
    var timer = setInterval(function () {
        if (window.sessionStorage.getItem('phantomOnlineGlobalConfig')) {
            clearInterval(timer);
            var serverUrlConfig = JSON.parse(window.sessionStorage.getItem('phantomOnlineGlobalConfig'));
            var CASURI = serverUrlConfig.casApiUrl;
            window.sessionStorage.clear();
            window.sessionStorage.clear();
            window.location.href = CASURI + "/cas/logout?service=" + service;
            callback && callback();
        }
    }, 200);
}
/**
 * 函数功能简述
 * 登录跳转到cas页面
 *
 */
export function loginFn() {
    return __awaiter(this, void 0, void 0, function () {
        var uri, phantomOnlineGlobalConfig;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    window.sessionStorage.setItem('pathname', '');
                    console.log(window.location.search);
                    if (window.location.search.indexOf('action') !== -1) {
                        uri = encodeURIComponent(window.location.protocol + "//" + window.location.host);
                    }
                    else {
                        uri = encodeURIComponent(window.location.protocol + "//" + window.location.host + window.location.search);
                    }
                    if (!window.sessionStorage.getItem('phantomOnlineGlobalConfig')) return [3 /*break*/, 1];
                    casLogin(uri);
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, loadUrlConfig()];
                case 2:
                    phantomOnlineGlobalConfig = _a.sent();
                    window.sessionStorage.setItem("phantomOnlineGlobalConfig", JSON.stringify(phantomOnlineGlobalConfig));
                    casLogin(uri);
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function casLogin(uri) {
    window.phantomOnlineGlobalConfig = JSON.parse(window.sessionStorage.getItem('phantomOnlineGlobalConfig'));
    var CASURI = window.phantomOnlineGlobalConfig.casApiUrl;
    var la = navigator.language.replace('-', '_'); //"zh_CN"//"en-US";//
    console.log("CASURI = " + CASURI + navigator.language);
    window.location.href = CASURI + "/cas/login?service=" + uri + "&al=" + la;
}
/**
 * 函数功能简述
 *
 * 具体描述一些细节
 *
 * @param    {object}    config             配置 content 消息框内容  title 消息框标题  type 消息框类型 可选择 success/info/warning/error
 * @param    {function}  confirmCallback    用户点击确认
 * @param    {function}  cancelCallback     用户点击取消
 * @returns  void
 */
export function showMessageConfirmBox(config, confirmCallback, cancelCallback) {
}
//转cpdf文档
export function queryDocumentTask(fid) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = baseURI + '/cpdfapi/v2/documents/queryTask?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        data: { fid: fid },
                        success: function (data) {
                            if (data.code === 100000) {
                                resolve(data);
                            }
                            else {
                                reject(data);
                            }
                        }
                    });
                })];
        });
    });
}
//签名任务
export function querySignTask(taskid) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/sign-task/query?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        data: { taskid: taskid },
                        success: function (data) {
                            if (data.code === 100000) {
                                resolve(data);
                            }
                            else {
                                reject(data);
                            }
                        }
                    });
                })];
        });
    });
}
//webpdf任务
export function queryWebPDFTask(taskid) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = webpdfURI + ("/api/v2/task/" + taskid + "/query?access-token=") + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        success: function (res) {
                            if (res.resultCode === "0" && res.resultBody.result == "0") {
                                resolve(res.resultBody);
                            }
                            else {
                                reject(res);
                            }
                        }
                    });
                })];
        });
    });
}
export function connectedSign(cDocID, Type) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: {
                            "cDocID": cDocID,
                            "cSignType": Type,
                        },
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//设置签名的位置、颜色
export function addSignFields(docSignId, signFields) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + ("/cpdfapi/v1/connected-sign/" + docSignId + "?access-token=" + selector.getToken(store.getState()));
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: {
                            "signListDetail": signFields.map(function (signField) { return JSON.stringify(signField); })
                        },
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//获取某个文档的所有签名数据
export function getSignInfo(docSignId) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/' + docSignId + '?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        success: function (res) {
                            if (res.ret == 0) {
                                resolve(res.data);
                            }
                            else {
                                reject(res);
                            }
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
export function getDocManifestInfo(webPdfDocID) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = webpdfURI + '/api/v2/parser/' + webPdfDocID + "/manifest";
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        data: {
                            "access-token": selector.getToken(store.getState()),
                            autoParse: true
                        },
                        success: function (res) {
                            if (res.resultCode == "0") {
                                resolve(JSON.parse(res.resultBody.manifest));
                            }
                            else {
                                reject(res);
                            }
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//设置签名人的顺序
export function postSigingOrder(signers, docSignId) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/' + docSignId + '?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: {
                            "signList": signers,
                        },
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//发送邀请邮件的标题 邀请邮件的附加内容  status:1    签名流程结束
export function postInvite(subject, message, docSignId) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/' + docSignId + '?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: {
                            "inviteSubject": subject,
                            "inviteMessage": message,
                            "status": 1,
                        },
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//获取用户创建或被分享的模板的签名模板 2=自行创建模板, 3=被分享的模板
export function getTemplateAll(signType) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/template/all?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        data: {
                            "signType": signType
                        },
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//获取用户发起的所有签名流程
//  status: 1 To_be_signed 2 Done; 
//  signStatus: 1 To_be_signed 2 Signed 0 In_the_signature
export function getConnectedSignAll() {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/all?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//获取需要签名的文档列表
export function getConnectedSign() {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
export function uploadMySign(signType, imgBase64) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/my-sign?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: { signType: signType, imgBase64: imgBase64 },
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
export function saveDocSign(signId, signContent) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + ("/cpdfapi/v1/connected-sign/sign/" + signId + "?access-token=") + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: { signContent: JSON.stringify({ graphics: signContent }) },
                        success: function (res) {
                            resolve(res);
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
export function saveFormValues(webPdfDocID, formValues) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = webpdfURI + ("/api/v2/doc/" + webPdfDocID + "/operation?access-token=") + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: { opts: JSON.stringify({ "form": formValues }) },
                        success: function (res) {
                            if (res.resultCode == "1") {
                                resolve(res.resultBody);
                            }
                            else {
                                reject(res);
                            }
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
export function convertCPDF(docid, formValues) {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = webpdfURI + ("/api/v2/cpdf/" + docid + "/convert?access-token=") + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'POST',
                        url: url,
                        data: { opts: JSON.stringify({ "form": formValues }) },
                        success: function (res) {
                            if (res.resultCode == "1") {
                                resolve(res.resultBody);
                            }
                            else {
                                reject(res);
                            }
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
export function getMySign() {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            url = CWSURI + '/cpdfapi/v1/connected-sign/my-sign?access-token=' + selector.getToken(store.getState());
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    $.ajax({
                        type: 'GET',
                        url: url,
                        cache: false,
                        success: function (res) {
                            if (res.ret == 0) {
                                resolve(res.data);
                            }
                            else {
                                reject(res);
                            }
                        },
                        error: function (error) {
                            reject(error);
                        }
                    });
                })];
        });
    });
}
//# sourceMappingURL=index.js.map