import { h } from "preact";
import { connect } from 'preact-redux';
import * as actions from '../webpdf/actions';
import DocView from "./DocView";
import BtmToolBar from "./BtmToolBar";
import * as selectors from "../webpdf/selectors";
import UserAgent from "../vendor/UserAgent_DEPRECATED";
var App = function (props, context) {
    var pageCount = props.pageCount, pageIndex = props.pageIndex, docViewHeight = props.docViewHeight, docViewWidth = props.docViewWidth, zoom = props.zoom, manifestInfo = props.manifestInfo, userInfo = props.userInfo, serverUrl = props.serverUrl, docId = props.docId, setDocViewSize = props.setDocViewSize, setZoom = props.setZoom, setPageIndex = props.setPageIndex, autoParse = props.autoParse, imageWithAnnot = props.imageWithAnnot, imageWithForm = props.imageWithForm, plugins = props.plugins;
    return (h("div", { class: "full" },
        h(DocView, { manifestInfo: manifestInfo, userInfo: userInfo, docId: docId, serverUrl: serverUrl, pageIndex: pageIndex, pageCount: pageCount, zoom: zoom, setDocViewSize: setDocViewSize, setZoom: setZoom, setPageIndex: setPageIndex, autoParse: autoParse, imageWithAnnot: imageWithAnnot, imageWithForm: imageWithForm, plugins: plugins }),
        !UserAgent.mobile() && h(BtmToolBar, { manifestInfo: manifestInfo, pageIndex: pageIndex, pageCount: pageCount, docViewHeight: docViewHeight, docViewWidth: docViewWidth, zoom: zoom, setPageIndex: setPageIndex, setZoom: setZoom })));
};
var mapStateToProps = function (state, ownProps) {
    return {
        pageIndex: selectors.getPageIndex(state),
        pageCount: selectors.getPageCount(state),
        zoom: selectors.getCurZooom(state),
        docViewWidth: selectors.getDocViewWidth(state),
        docViewHeight: selectors.getDocViewHeight(state),
        manifestInfo: selectors.getManifestInfo(state),
        autoParse: selectors.getAutoParse(state),
        imageWithAnnot: selectors.getImageWithAnnot(state),
        imageWithForm: selectors.getImageWithForm(state),
        userInfo: selectors.getUserInfo(state),
        serverUrl: selectors.getServerUrl(state),
        docId: selectors.getDocId(state)
    };
};
export default connect(mapStateToProps, actions)(App);
//# sourceMappingURL=App.js.map