var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h, Component } from "preact";
import UserAgent_DEPRECATED from "../vendor/UserAgent_DEPRECATED";
import DocViewSizeHelper from "./DocViewSizeHelper";
import { setZoom } from "../webpdf/actions";
import bind from "../vendor/bind";
require('../style/ricon.less');
var BtmToolBar = /** @class */ (function (_super) {
    __extends(BtmToolBar, _super);
    function BtmToolBar(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            zoomList: [],
            showZoomList: false,
            showPageIndex: false,
            showBar: false
        };
        _this.docViewSizeHelper = new DocViewSizeHelper(props.manifestInfo);
        return _this;
    }
    BtmToolBar.prototype.componentDidMount = function () {
        var _this = this;
        this.setZoomList(this.props);
        setTimeout(function () {
            _this.setState({ showBar: true });
        }, 0);
    };
    BtmToolBar.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.docViewWidth != nextProps.docViewWidth) {
            this.setZoomList(nextProps);
        }
    };
    BtmToolBar.prototype.setZoomList = function (props) {
        var docViewWidth = props.docViewWidth;
        var zoomList = [];
        zoomList.push({ name: "50%", value: 0.5 });
        zoomList.push({ name: "75%", value: 0.75 });
        zoomList.push({ name: "100%", value: 1 });
        zoomList.push({ name: "125%", value: 1.25 });
        zoomList.push({ name: "150%", value: 1.5 });
        zoomList.push({ name: "175%", value: 1.75 });
        zoomList.push({ name: "200%", value: 2 });
        var pageWidth = this.docViewSizeHelper.getMaxPageWidth(1);
        var fitWidth = docViewWidth / pageWidth;
        zoomList.push({ name: "适应宽度", value: fitWidth });
        if (UserAgent_DEPRECATED.mobile()) {
            zoomList = zoomList.filter(function (zoom) { return zoom.value >= fitWidth; });
            this.props, setZoom(fitWidth);
        }
        this.setState({ zoomList: zoomList });
    };
    BtmToolBar.prototype.onClickPageSelectInput = function () {
        this.setState({ showPageIndex: true, showZoomList: false });
        this.pageSelectInput.focus();
    };
    BtmToolBar.prototype.onBlurPageSelectInput = function () {
        var _this = this;
        setTimeout(function () {
            _this.setState({ showPageIndex: false });
        }, 500);
    };
    BtmToolBar.prototype.onClickZoomSelectInput = function () {
        this.setState({ showZoomList: true, showPageIndex: false });
        this.zoomSelectInput.focus();
    };
    BtmToolBar.prototype.onBlurZoomSelectInput = function () {
        var _this = this;
        setTimeout(function () {
            _this.setState({ showZoomList: false });
        }, 500);
    };
    BtmToolBar.prototype.onClickZoom = function (zoom) {
        this.props.setZoom(zoom);
        this.setState({ showZoomList: false });
    };
    BtmToolBar.prototype.onClickPageIndex = function (pageIndex) {
        this.props.setPageIndex(pageIndex);
    };
    BtmToolBar.prototype.onPrev = function () {
        var pageIndex = this.props.pageIndex;
        if (pageIndex <= 0) {
            return;
        }
        this.props.setPageIndex(pageIndex - 1);
    };
    BtmToolBar.prototype.onNext = function () {
        var _a = this.props, pageIndex = _a.pageIndex, pageCount = _a.pageCount;
        if (pageIndex >= pageCount - 1) {
            return;
        }
        this.props.setPageIndex(pageIndex + 1);
    };
    BtmToolBar.prototype.getZoomLGValue = function (value) {
        var zoomList = this.state.zoomList.sort(function (a, b) { return a.value < b.value ? -1 : 1; });
        for (var i = 0; i < zoomList.length; i++) {
            if (zoomList[i].value > value) {
                return zoomList[i];
            }
        }
        return null;
    };
    BtmToolBar.prototype.getZoomSMValue = function (value) {
        var zoomList = this.state.zoomList.sort(function (a, b) { return a.value < b.value ? -1 : 1; });
        for (var i = zoomList.length - 1; i >= 0; i--) {
            if (zoomList[i].value < value) {
                return zoomList[i];
            }
        }
        return null;
    };
    BtmToolBar.prototype.onZoomIn = function () {
        var nextZoom = this.getZoomLGValue(this.props.zoom);
        if (nextZoom) {
            this.props.setZoom(nextZoom.value);
        }
    };
    BtmToolBar.prototype.onZoomOut = function () {
        var nextZoom = this.getZoomSMValue(this.props.zoom);
        if (nextZoom) {
            this.props.setZoom(nextZoom.value);
        }
    };
    BtmToolBar.prototype.render = function () {
        var _this = this;
        var _a = this.props, zoom = _a.zoom, pageCount = _a.pageCount, pageIndex = _a.pageIndex;
        var _b = this.state, zoomList = _b.zoomList, showZoomList = _b.showZoomList, showPageIndex = _b.showPageIndex, showBar = _b.showBar;
        var pageIndexs = [];
        for (var i = 0; i < pageCount; i++) {
            pageIndexs.push(h("li", { class: "fwr-select-option-li selected", onClick: this.onClickPageIndex.bind(this, i + 1) }, i + 1 + " / " + pageCount));
        }
        return (h("div", { class: "fwr-rb-bottom-tabs", style: { display: showBar ? "block" : "none" } },
            h("ul", { class: "fwr-rb-bottom-tab" },
                h("li", { id: "selectPagePanel", class: "fwr-rb-gotopage-group" },
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-page-prev", onClick: this.onPrev }),
                    h("div", { id: "gotoPagesBox", class: "fwr-rb-page-box" },
                        h("input", { ref: function (ref) { return _this.pageSelectInput = ref; }, tabIndex: 1, id: "pageSelectInput", value: pageIndex + 1 + " / " + pageCount, readOnly: true, onClick: this.onClickPageSelectInput, onBlur: this.onBlurPageSelectInput }),
                        showPageIndex && h("div", { id: "pageSelectBox", class: "fwr-bottom-select-optionbox" },
                            h("ul", { id: "pageSelectOption", class: "fwr-bottom-select-option" }, pageIndexs))),
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-page-next", onClick: this.onNext })),
                h("li", { class: "fwr-rb-zoom-group" },
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-zoomout", onClick: this.onZoomOut }),
                    h("div", { class: "fwr-rb-zoom-box" },
                        h("input", { ref: function (ref) { return _this.zoomSelectInput = ref; }, tabIndex: 2, value: Math.round(zoom * 100) + "%", readOnly: true, onClick: this.onClickZoomSelectInput, onBlur: this.onBlurZoomSelectInput }),
                        showZoomList && h("div", { id: "zoomSelectBox1", class: "fwr-bottom-select-optionbox" },
                            h("ul", { id: "zoomselectoption1", class: "fwr-bottom-select-option" }, zoomList
                                .sort(function (a, b) { return a.value < b.value ? -1 : 1; })
                                .map(function (zoomItem) { return h("li", { key: zoomItem.name, onClick: _this.onClickZoom.bind(_this, zoomItem.value), class: "fwr-select-option-li" }, zoomItem.name); })))),
                    h("i", { onClick: this.onZoomIn, class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-zoomin" })),
                h("li", { class: "fwr-rb-leftrotate hide" },
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-leftrotate" })),
                h("li", { class: "fwr-rb-rightrotate hide" },
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-rightrotate" })),
                h("li", { class: "fwr-rb-singlepage hide" },
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-singlepage" })),
                h("li", { class: "fwr-rb-continuouspages selected hide" },
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-continuouspages" })),
                h("li", { class: "fwr-rb-fullsceen hide", style: "display: none;" },
                    h("i", { class: "bottom-tip fwr-rb-bottom-icons fwr-rb-bottom-fullsceen" })))));
    };
    __decorate([
        bind
    ], BtmToolBar.prototype, "setZoomList", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onClickPageSelectInput", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onBlurPageSelectInput", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onClickZoomSelectInput", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onBlurZoomSelectInput", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onClickZoom", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onClickPageIndex", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onPrev", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onNext", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onZoomIn", null);
    __decorate([
        bind
    ], BtmToolBar.prototype, "onZoomOut", null);
    return BtmToolBar;
}(Component));
export default BtmToolBar;
//# sourceMappingURL=BtmToolBar.js.map