var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h, Component } from "preact";
import DocViewRowBuffer from "./DocViewRowBuffer";
import DocViewPage from "./DocViewPage";
import Rect from "./Rect";
import bind from "../vendor/bind";
var DocViewBufferedRows = /** @class */ (function (_super) {
    __extends(DocViewBufferedRows, _super);
    function DocViewBufferedRows(props) {
        var _this = _super.call(this, props) || this;
        _this._rowBuffer =
            new DocViewRowBuffer(_this.props.rowsCount, _this.props.defaultRowHeight, _this.props.height, _this._getRowHeight);
        _this.state = {
            rowsToRender: _this._rowBuffer.getRows(_this.props.firstRowIndex, _this.props.firstRowOffset),
        };
        if (_this.state.rowsToRender.length > 20) {
            debugger;
        }
        return _this;
    }
    DocViewBufferedRows.prototype.componentDidMount = function () {
        this._isMounted = true;
        setTimeout(this._updateBuffer, 1000);
    };
    DocViewBufferedRows.prototype.componentWillMount = function () {
        this._staticRowArray = [];
    };
    DocViewBufferedRows.prototype.shouldComponentUpdate = function () {
        // Don't add PureRenderMixin to this component please.
        return true;
    };
    DocViewBufferedRows.prototype.componentWillUnmount = function () {
        this._isMounted = false;
        this._staticRowArray.length = 0;
    };
    DocViewBufferedRows.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.rowsCount !== this.props.rowsCount ||
            nextProps.height !== this.props.height) {
            this._rowBuffer =
                new DocViewRowBuffer(nextProps.rowsCount, nextProps.defaultRowHeight, nextProps.height, this._getRowHeight);
        }
        if (this.props.isScrolling && !nextProps.isScrolling) {
            this._updateBuffer();
        }
        else {
            this.setState({
                rowsToRender: this._rowBuffer.getRows(nextProps.firstRowIndex, nextProps.firstRowOffset)
            });
        }
    };
    DocViewBufferedRows.prototype._updateBuffer = function () {
        if (this._isMounted) {
            this.setState({
                rowsToRender: this._rowBuffer.getRowsWithUpdatedBuffer(),
            });
        }
    };
    DocViewBufferedRows.prototype._getRowHeight = function (index) {
        return this.props.rowHeightGetter ?
            this.props.rowHeightGetter(index) :
            this.props.defaultRowHeight;
    };
    DocViewBufferedRows.prototype.render = function (props, state) {
        var rowsToRender = state.rowsToRender;
        var zoom = props.zoom, scrollY = props.scrollY, firstRowIndex = props.firstRowIndex, rowWidthGetter = props.rowWidthGetter, rowPositionGetter = props.rowPositionGetter, visibleDocRect = props.visibleDocRect;
        //console.log("render buffered Rows")
        this._staticRowArray.length = rowsToRender.length;
        for (var i = 0; i < rowsToRender.length; ++i) {
            var rowIndex = rowsToRender[i];
            var rowHeight = this._getRowHeight(rowIndex);
            var rowOffsetTop = rowPositionGetter(rowIndex);
            var rowWidth = rowWidthGetter(rowIndex);
            var left = Math.max(0, (props.width - rowWidth) / 2);
            var pageAboveRect = new Rect({ top: scrollY, height: props.height, left: 0, width: props.width }).overlap(new Rect({ top: rowOffsetTop, height: rowHeight, left: 0, width: rowWidth })).offset(0, rowOffsetTop);
            var pageRect = new Rect({ top: rowOffsetTop, left: left + props.scrollX, width: rowWidth, height: rowHeight });
            var visiblePageRect = visibleDocRect.overlap(pageRect).offset(left, rowOffsetTop);
            this._staticRowArray[i] =
                h(DocViewPage, { key: rowIndex, pageIndex: rowIndex, zoom: props.zoom, visiblePageRect: visiblePageRect, pageAboveRect: pageAboveRect, height: rowHeight, width: rowWidth, offsetTop: rowOffsetTop, left: Math.max(0, (props.width - rowWidth) / 2) });
        }
        var style = {
            pointerEvents: props.isScrolling ? 'none' : 'auto',
        };
        return (h("div", { style: style }, this._staticRowArray));
    };
    __decorate([
        bind
    ], DocViewBufferedRows.prototype, "_getRowHeight", null);
    return DocViewBufferedRows;
}(Component));
export default DocViewBufferedRows;
//# sourceMappingURL=DocViewBufferedRows.js.map