function zoomToKey(zoom) {
    return zoom.toString();
}
export var PAGE_PADDING = 20;
var DocViewSizeHelper = /** @class */ (function () {
    function DocViewSizeHelper(manifestInfo) {
        this._totalWidthCache = {};
        this._manifestInfo = manifestInfo;
    }
    DocViewSizeHelper.prototype.getMaxPageWidth = function (zoom) {
        if (this._totalWidthCache[zoomToKey(zoom)]) {
            return this._totalWidthCache[zoomToKey(zoom)];
        }
        else {
            var pagesInfo = this._manifestInfo.PagesInfo;
            var totalWidth = pagesInfo.reduce(function (previousValue, pageInfo) {
                return Math.max(previousValue, pageInfo.width * 1.333 * zoom);
            }, 0);
            this._totalWidthCache[zoomToKey(zoom)] = totalWidth;
            return totalWidth;
        }
    };
    DocViewSizeHelper.prototype.getPageSize = function (pageIndex, zoom) {
        var pagesInfo = this._manifestInfo.PagesInfo;
        if (pageIndex >= 0 && pageIndex < pagesInfo.length) {
            return {
                width: pagesInfo[pageIndex].width * 1.33 * zoom,
                height: pagesInfo[pageIndex].height * 1.33 * zoom + PAGE_PADDING
            };
        }
        else {
            return {
                width: 0,
                height: 0
            };
        }
    };
    DocViewSizeHelper.prototype.getDefaultRowHeight = function (zoom) {
        return this.getPageSize(0, zoom).height;
    };
    DocViewSizeHelper.prototype.getDefaultRowWidth = function (zoom) {
        return this.getMaxPageWidth(zoom);
    };
    return DocViewSizeHelper;
}());
export default DocViewSizeHelper;
//# sourceMappingURL=DocViewSizeHelper.js.map