var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { h, Component } from "preact";
var Modal = /** @class */ (function (_super) {
    __extends(Modal, _super);
    function Modal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.checkUnderlayClick = function (event) {
            if (_this.dialogNode && _this.dialogNode.contains(event.target))
                return;
            _this.exit();
        };
        _this.exit = function () {
            if (_this.props.onExit) {
                _this.props.onExit();
            }
        };
        return _this;
    }
    Modal.prototype.render = function (props) {
        var _this = this;
        var underlayStyle = {
            position: 'fixed',
            top: 0,
            left: 0,
            width: '100%',
            height: '100%',
            zIndex: 1050,
            overflowX: 'hidden',
            overflowY: 'auto',
            WebkitOverflowScrolling: 'touch',
            textAlign: 'center',
            background: 'rgba(0, 0, 0, 0.5)',
        };
        if (props.underlayClickExits) {
            underlayStyle.cursor = 'pointer';
        }
        var dialogStyle = Object.assign({
            display: 'inline-block',
            textAlign: 'left',
            top: 0,
            maxWidth: '100%',
            cursor: 'default',
            outline: 0,
            verticalAlign: "middle"
        }, this.props.dialogStyle);
        var verticalCenterStyle = {
            display: 'inline-block',
            height: '100%',
            verticalAlign: 'middle',
        };
        var underlayProps = {
            style: underlayStyle,
            id: this.props.id
        };
        if (props.underlayClickExits) {
            underlayProps.onClick = this.checkUnderlayClick;
        }
        var dialogProps = {
            key: 'b',
            ref: function (el) {
                _this.dialogNode = el;
            },
            role: 'dialog',
            style: dialogStyle
        };
        return (h("div", __assign({}, underlayProps),
            h("div", { key: "a", style: verticalCenterStyle }),
            h("div", __assign({}, dialogProps), this.props.children)));
    };
    Modal.defaultProps = {
        underlayClickExits: true
    };
    return Modal;
}(Component));
export default Modal;
//# sourceMappingURL=Modal.js.map