var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h, Component } from "preact";
import Resizer from "./resizer";
import * as style from "dom-helpers/style";
import * as getComputedStyle from "dom-helpers/style/getComputedStyle";
import getEventClientPos from "../../vendor/getPtClientPos";
import DOMMouseMoveTracker from "../../vendor/DOMMouseMoveTracker";
import bind from "../../vendor/bind";
import clamp from "../../vendor/clamp";
var userSelectNone = {
    userSelect: 'none',
    MozUserSelect: 'none',
    WebkitUserSelect: 'none',
    MsUserSelect: 'none',
};
var userSelectAuto = {
    userSelect: 'auto',
    MozUserSelect: 'auto',
    WebkitUserSelect: 'auto',
    MsUserSelect: 'auto',
};
var endsWith = function (str, searchStr) {
    return str.substr(str.length - searchStr.length, searchStr.length) === searchStr;
};
var getStringSize = function (n) {
    if (endsWith(n.toString(), 'px'))
        return n.toString();
    if (endsWith(n.toString(), '%'))
        return n.toString();
    return n + "px";
};
var definedProps = [
    'style',
    'class',
    'grid',
    'bounds',
    'size',
    'defaultSize',
    'minWidth',
    'minHeight',
    'maxWidth',
    'maxHeight',
    'lockAspectRatio',
    'lockAspectRatioExtraWidth',
    'lockAspectRatioExtraHeight',
    'enable',
    'handleStyles',
    'handleClasses',
    'handleWrapperStyle',
    'handleWrapperClass',
    'children',
    'onResizeStart',
    'onResize',
    'onResizeStop',
    'handleComponent',
    'ref'
];
var Resizable = /** @class */ (function (_super) {
    __extends(Resizable, _super);
    function Resizable(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            isResizing: false,
            resizeCursor: 'auto',
            width: typeof (_this.propsSize && _this.propsSize.width) === 'undefined'
                ? 'auto'
                : (_this.propsSize && _this.propsSize.width),
            height: typeof (_this.propsSize && _this.propsSize.height) === 'undefined'
                ? 'auto'
                : (_this.propsSize && _this.propsSize.height),
            direction: 'right',
            original: {
                x: 0,
                y: 0,
                width: 0,
                height: 0,
            },
        };
        _this.updateExtendsProps(props);
        return _this;
    }
    Resizable.prototype.componentDidMount = function () {
        var size = this.size;
        this.setState({
            width: this.state.width || size.width,
            height: this.state.height || size.height,
        });
        this._mouseMoveTracker = new DOMMouseMoveTracker(this._onMouseMove, this._onMouseMoveEnd, document.documentElement);
    };
    Resizable.prototype.componentWillUnmount = function () {
        this._mouseMoveTracker.releaseMouseMoves();
    };
    Resizable.prototype.componentWillReceiveProps = function (next) {
        this.updateExtendsProps(next);
    };
    Resizable.prototype.updateExtendsProps = function (props) {
        this.extendsProps = Object.keys(props).reduce(function (acc, key) {
            if (definedProps.indexOf(key) !== -1)
                return acc;
            acc[key] = props[key];
            return acc;
        }, {});
    };
    Object.defineProperty(Resizable.prototype, "propsSize", {
        get: function () {
            return this.props.size || this.props.defaultSize;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Resizable.prototype, "size", {
        get: function () {
            var width = 0;
            var height = 0;
            if (typeof window !== 'undefined') {
                var orgWidth = this.resizable.offsetWidth;
                var orgHeight = this.resizable.offsetHeight;
                // HACK: Set position `relative` to get parent size.
                // This is because when re-resizable set `absolute`, I can not get base width correctly.
                var orgPosition = this.resizable.style.position;
                if (orgPosition !== 'relative') {
                    this.resizable.style.position = 'relative';
                }
                // INFO: Use original width or height if set auto.
                width = this.resizable.style.width !== 'auto' ? this.resizable.offsetWidth : orgWidth;
                height = this.resizable.style.height !== 'auto' ? this.resizable.offsetHeight : orgHeight;
                // Restore original position
                this.resizable.style.position = orgPosition;
            }
            return { width: width, height: height };
        },
        enumerable: true,
        configurable: true
    });
    Resizable.prototype.sizeStyle = function () {
        var _this = this;
        var size = this.props.size;
        var getSize = function (key) {
            if (typeof _this.state[key] === 'undefined' || _this.state[key] === 'auto')
                return 'auto';
            if (_this.propsSize && _this.propsSize[key] && endsWith(_this.propsSize[key].toString(), '%')) {
                if (endsWith(_this.state[key].toString(), '%'))
                    return _this.state[key].toString();
                var parentSize = _this.getParentSize();
                var value = Number(_this.state[key].toString().replace('px', ''));
                var percent = (value / parentSize[key]) * 100;
                return percent + "%";
            }
            return getStringSize(_this.state[key]);
        };
        var width = size && typeof size.width !== 'undefined' && !this.state.isResizing
            ? getStringSize(size.width)
            : getSize('width');
        var height = size && typeof size.height !== 'undefined' && !this.state.isResizing
            ? getStringSize(size.height)
            : getSize('height');
        return { width: width, height: height };
    };
    Resizable.prototype.parentNode = function () {
        return this.resizable.parentNode;
    };
    Resizable.prototype._onMouseMove = function (deltaX, deltaY, _a) {
        var clientX = _a.clientX, clientY = _a.clientY;
        if (!this.state.isResizing)
            return;
        var _b = this.state, direction = _b.direction, original = _b.original, width = _b.width, height = _b.height;
        var _c = this.props, lockAspectRatio = _c.lockAspectRatio, lockAspectRatioExtraHeight = _c.lockAspectRatioExtraHeight, lockAspectRatioExtraWidth = _c.lockAspectRatioExtraWidth;
        var _d = this.props, maxWidth = _d.maxWidth, maxHeight = _d.maxHeight, minWidth = _d.minWidth, minHeight = _d.minHeight;
        // TODO: refactor
        var parentSize = this.getParentSize();
        if (maxWidth && typeof maxWidth === 'string' && endsWith(maxWidth, '%')) {
            var ratio_1 = Number(maxWidth.replace('%', '')) / 100;
            maxWidth = parentSize.width * ratio_1;
        }
        if (maxHeight && typeof maxHeight === 'string' && endsWith(maxHeight, '%')) {
            var ratio_2 = Number(maxHeight.replace('%', '')) / 100;
            maxHeight = parentSize.height * ratio_2;
        }
        if (minWidth && typeof minWidth === 'string' && endsWith(minWidth, '%')) {
            var ratio_3 = Number(minWidth.replace('%', '')) / 100;
            minWidth = parentSize.width * ratio_3;
        }
        if (minHeight && typeof minHeight === 'string' && endsWith(minHeight, '%')) {
            var ratio_4 = Number(minHeight.replace('%', '')) / 100;
            minHeight = parentSize.height * ratio_4;
        }
        maxWidth = typeof maxWidth === 'undefined' ? undefined : Number(maxWidth);
        maxHeight = typeof maxHeight === 'undefined' ? undefined : Number(maxHeight);
        minWidth = typeof minWidth === 'undefined' ? undefined : Number(minWidth);
        minHeight = typeof minHeight === 'undefined' ? undefined : Number(minHeight);
        var ratio = typeof lockAspectRatio === 'number' ? lockAspectRatio : original.width / original.height;
        var newWidth = original.width;
        var newHeight = original.height;
        if (/right/i.test(direction)) {
            newWidth = original.width + (clientX - original.x);
            if (lockAspectRatio)
                newHeight = (newWidth - lockAspectRatioExtraWidth) / ratio + lockAspectRatioExtraHeight;
        }
        if (/left/i.test(direction)) {
            newWidth = original.width - (clientX - original.x);
            if (lockAspectRatio)
                newHeight = (newWidth - lockAspectRatioExtraWidth) / ratio + lockAspectRatioExtraHeight;
        }
        if (/bottom/i.test(direction)) {
            newHeight = original.height + (clientY - original.y);
            if (lockAspectRatio)
                newWidth = (newHeight - lockAspectRatioExtraHeight) * ratio + lockAspectRatioExtraWidth;
        }
        if (/top/i.test(direction)) {
            newHeight = original.height - (clientY - original.y);
            if (lockAspectRatio)
                newWidth = (newHeight - lockAspectRatioExtraHeight) * ratio + lockAspectRatioExtraWidth;
        }
        if (this.props.bounds === 'parent') {
            var parent_1 = this.parentNode();
            if (parent_1 instanceof HTMLElement) {
                var parentRect = parent_1.getBoundingClientRect();
                var parentLeft = parentRect.left;
                var parentTop = parentRect.top;
                var _e = this.resizable.getBoundingClientRect(), left = _e.left, top_1 = _e.top;
                var boundWidth = parent_1.offsetWidth + (parentLeft - left);
                var boundHeight = parent_1.offsetHeight + (parentTop - top_1);
                maxWidth = maxWidth && maxWidth < boundWidth ? maxWidth : boundWidth;
                maxHeight = maxHeight && maxHeight < boundHeight ? maxHeight : boundHeight;
            }
        }
        else if (this.props.bounds === 'window') {
            if (typeof window !== 'undefined') {
                var _f = this.resizable.getBoundingClientRect(), left = _f.left, top_2 = _f.top;
                var boundWidth = window.innerWidth - left;
                var boundHeight = window.innerHeight - top_2;
                maxWidth = maxWidth && maxWidth < boundWidth ? maxWidth : boundWidth;
                maxHeight = maxHeight && maxHeight < boundHeight ? maxHeight : boundHeight;
            }
        }
        else if (this.props.bounds instanceof HTMLElement) {
            var targetRect = this.props.bounds.getBoundingClientRect();
            var targetLeft = targetRect.left;
            var targetTop = targetRect.top;
            var _g = this.resizable.getBoundingClientRect(), left = _g.left, top_3 = _g.top;
            if (!(this.props.bounds instanceof HTMLElement))
                return;
            var boundWidth = this.props.bounds.offsetWidth + (targetLeft - left);
            var boundHeight = this.props.bounds.offsetHeight + (targetTop - top_3);
            maxWidth = maxWidth && maxWidth < boundWidth ? maxWidth : boundWidth;
            maxHeight = maxHeight && maxHeight < boundHeight ? maxHeight : boundHeight;
        }
        var computedMinWidth = typeof minWidth === 'undefined' ? 10 : minWidth;
        var computedMaxWidth = typeof maxWidth === 'undefined' || maxWidth < 0 ? newWidth : maxWidth;
        var computedMinHeight = typeof minHeight === 'undefined' ? 10 : minHeight;
        var computedMaxHeight = typeof maxHeight === 'undefined' || maxHeight < 0 ? newHeight : maxHeight;
        if (lockAspectRatio) {
            var extraMinWidth = (computedMinHeight - lockAspectRatioExtraHeight) * ratio + lockAspectRatioExtraWidth;
            var extraMaxWidth = (computedMaxHeight - lockAspectRatioExtraHeight) * ratio + lockAspectRatioExtraWidth;
            var extraMinHeight = (computedMinWidth - lockAspectRatioExtraWidth) / ratio + lockAspectRatioExtraHeight;
            var extraMaxHeight = (computedMaxWidth - lockAspectRatioExtraWidth) / ratio + lockAspectRatioExtraHeight;
            var lockedMinWidth = Math.max(computedMinWidth, extraMinWidth);
            var lockedMaxWidth = Math.min(computedMaxWidth, extraMaxWidth);
            var lockedMinHeight = Math.max(computedMinHeight, extraMinHeight);
            var lockedMaxHeight = Math.min(computedMaxHeight, extraMaxHeight);
            newWidth = clamp(newWidth, lockedMinWidth, lockedMaxWidth);
            newHeight = clamp(newHeight, lockedMinHeight, lockedMaxHeight);
        }
        else {
            newWidth = clamp(newWidth, computedMinWidth, computedMaxWidth);
            newHeight = clamp(newHeight, computedMinHeight, computedMaxHeight);
        }
        var delta = {
            width: newWidth - original.width,
            height: newHeight - original.height,
        };
        if (width && typeof width === 'string' && endsWith(width, '%')) {
            var percent = (newWidth / parentSize.width) * 100;
            newWidth = percent + "%";
        }
        if (height && typeof height === 'string' && endsWith(height, '%')) {
            var percent = (newHeight / parentSize.height) * 100;
            newHeight = percent + "%";
        }
        this.setState({
            width: this.calculateNewSize(newWidth, 'width'),
            height: this.calculateNewSize(newHeight, 'height'),
        });
        if (this.props.onResize) {
            this.props.onResize(direction, this.resizable, delta);
        }
    };
    Resizable.prototype._onMouseMoveEnd = function () {
        this._mouseMoveTracker.releaseMouseMoves();
        var _a = this.state, isResizing = _a.isResizing, direction = _a.direction, original = _a.original;
        if (!isResizing)
            return;
        var size = this.size;
        var delta = {
            width: size.width - original.width,
            height: size.height - original.height,
        };
        if (this.props.onResizeStop) {
            this.props.onResizeStop(direction, this.resizable, delta);
        }
        if (this.props.size) {
            this.setState(this.props.size);
        }
        this.setState({ isResizing: false, resizeCursor: 'auto' });
    };
    Resizable.prototype.calculateNewSize = function (newSize, kind) {
        var propsSize = this.propsSize && this.propsSize[kind];
        return this.state[kind] === 'auto' &&
            this.state.original[kind] === newSize &&
            (typeof propsSize === 'undefined' || propsSize === 'auto')
            ? 'auto'
            : newSize;
    };
    Resizable.prototype.getParentSize = function () {
        var base = this.base;
        if (!base)
            return { width: window.innerWidth, height: window.innerHeight };
        // INFO: To calculate parent width with flex layout
        var wrapChanged = false;
        var wrap = style(this.base.parentNode, "flexWrap");
        var minWidth = base.style.minWidth;
        if (wrap !== 'wrap') {
            wrapChanged = true;
            style(this.base.parentNode, "flexWrap", 'wrap');
            // HACK: Use relative to get parent padding size
        }
        base.style.position = 'relative';
        base.style.minWidth = '100%';
        var size = {
            width: base.offsetWidth,
            height: base.offsetHeight,
        };
        base.style.position = 'absolute';
        if (wrapChanged)
            style(this.base.parentNode, "flexWrap", wrap);
        base.style.minWidth = minWidth;
        return size;
    };
    Resizable.prototype.onResizeStart = function (event, direction) {
        if (event instanceof MouseEvent) {
            // When user click with right button the resize is stuck in resizing mode
            // until users clicks again, dont continue if right click is used.
            // HACK: MouseEvent does not have `which` from flow-bin v0.68.
            if (event.which === 3) {
                return;
            }
        }
        var _a = getEventClientPos(event), clientX = _a.clientX, clientY = _a.clientY;
        if (this.props.onResizeStart) {
            this.props.onResizeStart(event, direction, this.resizable);
        }
        // Fix #168
        if (this.props.size) {
            if (typeof this.props.size.height !== 'undefined' && this.props.size.height !== this.state.height) {
                this.setState({ height: this.props.size.height });
            }
            if (typeof this.props.size.width !== 'undefined' && this.props.size.width !== this.state.width) {
                this.setState({ width: this.props.size.width });
            }
        }
        var size = this.size;
        this.setState({
            original: {
                x: clientX,
                y: clientY,
                width: size.width,
                height: size.height,
            },
            isResizing: true,
            resizeCursor: getComputedStyle(event.target).cursor,
            direction: direction,
        });
        this._mouseMoveTracker.captureMouseMoves(event);
    };
    Resizable.prototype.renderResizer = function () {
        var _this = this;
        var _a = this.props, enable = _a.enable, handleStyles = _a.handleStyles, handleClasses = _a.handleClasses, handleWrapperStyle = _a.handleWrapperStyle, handleWrapperClass = _a.handleWrapperClass, handleComponent = _a.handleComponent;
        if (!enable)
            return null;
        var resizers = Object.keys(enable).map(function (dir) {
            if (enable[dir] !== false) {
                return (h(Resizer, { key: dir, direction: dir, onResizeStart: _this.onResizeStart, replaceStyles: handleStyles && handleStyles[dir], className: handleClasses && handleClasses[dir] }, handleComponent && handleComponent[dir]));
            }
            return null;
        });
        // #93 Wrap the resize box in span (will not break 100% width/height)
        return (h("span", { className: handleWrapperClass, style: handleWrapperStyle }, resizers));
    };
    Resizable.prototype.render = function () {
        var _this = this;
        var userSelect = this.state.isResizing ? userSelectNone : userSelectAuto;
        return h("div", __assign({ ref: function (c) {
                if (c) {
                    _this.resizable = c;
                }
            }, style: __assign({ position: 'relative' }, userSelect, this.props.style, this.sizeStyle(), { maxWidth: this.props.maxWidth, maxHeight: this.props.maxHeight, minWidth: this.props.minWidth, minHeight: this.props.minHeight, boxSizing: 'border-box' }), class: this.props.class }, this.extendsProps),
            this.state.isResizing && (h("div", { style: {
                    height: '100%',
                    width: '100%',
                    backgroundColor: 'rgba(0,0,0,0)',
                    cursor: "" + (this.state.resizeCursor || 'auto'),
                    opacity: '0',
                    position: 'fixed',
                    zIndex: '9999',
                    top: '0',
                    left: '0',
                    bottom: '0',
                    right: '0',
                } })),
            this.props.children,
            this.renderResizer());
    };
    Resizable.defaultProps = {
        onResizeStart: function () { },
        onResize: function () { },
        onResizeStop: function () { },
        enable: {
            top: true,
            right: true,
            bottom: true,
            left: true,
            topRight: true,
            bottomRight: true,
            bottomLeft: true,
            topLeft: true,
        },
        bounds: "parent",
        style: {},
        lockAspectRatio: false,
        lockAspectRatioExtraWidth: 0,
        lockAspectRatioExtraHeight: 0,
    };
    __decorate([
        bind
    ], Resizable.prototype, "_onMouseMove", null);
    __decorate([
        bind
    ], Resizable.prototype, "_onMouseMoveEnd", null);
    __decorate([
        bind
    ], Resizable.prototype, "onResizeStart", null);
    return Resizable;
}(Component));
export default Resizable;
//# sourceMappingURL=resizable.js.map