var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { h, Component } from "preact";
import { loadTileImage, getImageUrl } from "./loadTileImage";
import * as shallowEqual from "shallow-equals";
import cx from "../vendor/cx";
var TileInfo = /** @class */ (function () {
    function TileInfo(_a) {
        var row = _a.row, col = _a.col, pos = _a.pos;
        this.row = row;
        this.col = col;
        this.pos = pos;
    }
    TileInfo.prototype.position = function (scale) {
        return this.pos.scale(scale);
    };
    return TileInfo;
}());
export { TileInfo };
var Tile = /** @class */ (function (_super) {
    __extends(Tile, _super);
    function Tile(props, context) {
        var _this = _super.call(this, props) || this;
        var userInfo = context.userInfo, docId = context.docId, serverUrl = context.serverUrl, manifestInfo = context.manifestInfo, autoParse = context.autoParse, imageWithAnnot = context.imageWithAnnot, imageWithForm = context.imageWithForm;
        var _a = _this.props, pageIndex = _a.pageIndex, row = _a.row, col = _a.col, zoomName = _a.zoomName, tileSize = _a.tileSize;
        var url = getImageUrl({ docId: docId, pageIndex: pageIndex, rowIndex: row, colIndex: col, zoomName: zoomName, imageWithAnnot: imageWithAnnot, imageWithForm: imageWithForm });
        _this.state = {
            url: typeof url === "string" ? url : "",
        };
        _this._isMounted = true;
        if (!_this.state.url) {
            var userInfo_1 = context.userInfo, docId_1 = context.docId, serverUrl_1 = context.serverUrl, manifestInfo_1 = context.manifestInfo, autoParse_1 = context.autoParse, imageWithAnnot_1 = context.imageWithAnnot, imageWithForm_1 = context.imageWithForm;
            _this._canelToken = loadTileImage({
                pageIndex: pageIndex,
                rowIndex: row,
                colIndex: col,
                zoomName: zoomName,
                tileSize: tileSize,
                docId: docId_1,
                serverUrl: serverUrl_1,
                manifestInfo: manifestInfo_1,
                token: userInfo_1.token,
                autoParse: autoParse_1,
                imageWithAnnot: imageWithAnnot_1,
                imageWithForm: imageWithForm_1
            }, function (url) {
                _this._isMounted && _this.setState({ url: url });
            });
            _this.props.onLoading();
        }
        return _this;
    }
    Tile.prototype.componentDidMount = function () {
    };
    Tile.prototype.componentWillUnmount = function () {
        this._isMounted = false;
        this._canelToken && this._canelToken();
    };
    Tile.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !shallowEqual(this.state, nextState) || !shallowEqual(this.props, nextProps);
    };
    // @bind
    // onLoadImage() {
    //   this._isMounted && this.setState({ loaded: true })
    // }
    Tile.prototype.render = function (props, state) {
        var col = props.col, row = props.row, position = props.position, pageIndex = props.pageIndex, zoomName = props.zoomName;
        var url = state.url, loaded = state.loaded;
        // console.log("render Tile", pageIndex, col, row, position)
        return (h("img", { class: cx("tiles-" + row + "-" + col, { "image_unload": !url, "hide": !url }), src: url, style: {
                position: "absolute",
                top: position.top,
                left: position.left,
                width: position.width,
                height: position.height
            } }));
    };
    return Tile;
}(Component));
export default Tile;
//# sourceMappingURL=Tile.js.map