var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { h, Component } from "preact";
import { connect } from 'preact-redux';
import { Map, List } from "immutable";
import WidgetText from "./WidgetText";
import WidgetRadio from "./WidgetRadio";
import WidgetCheckBox from "./WidgetCheckBox";
import { FormWidgetType } from "../../form/models";
import { updateWidget } from "../../form/actions";
var FormPage = /** @class */ (function (_super) {
    __extends(FormPage, _super);
    function FormPage(props) {
        var _this = _super.call(this, props) || this;
        var pageIndex = props.pageIndex;
        return _this;
    }
    FormPage.prototype.getChildContext = function () {
        return {
            updateWidget: this.props.updateWidget,
            setItemValue: this.props.setItemValue,
        };
    };
    FormPage.prototype.componentWillReceiveProps = function (nextProps) {
    };
    FormPage.prototype.componentDidMount = function () {
    };
    FormPage.prototype.componentWillUnmount = function () {
    };
    FormPage.prototype.getWidgets = function (widgets, pageIndex) {
        var _this = this;
        var items = [];
        var zoom = this.props.zoom;
        widgets.forEach(function (widget) {
            if (widget.pageindex == pageIndex) {
                var value = _this.props.formItemValues.getIn([widget.name, "value"]);
                switch (widget.type) {
                    case FormWidgetType.Text:
                        items.push(h(WidgetText, { key: widget.id, data: widget, value: value, zoom: zoom }));
                        break;
                    case FormWidgetType.RadioButton:
                        items.push(h(WidgetRadio, { key: widget.id, data: widget, value: value, zoom: zoom }));
                        break;
                    case FormWidgetType.CheckBox:
                        items.push(h(WidgetCheckBox, { key: widget.id, data: widget, value: value, zoom: zoom }));
                        break;
                    default:
                        break;
                }
            }
        });
        return items;
    };
    FormPage.prototype.render = function () {
        var _a = this.props, pageIndex = _a.pageIndex, zoom = _a.zoom, widgets = _a.widgets;
        return h("div", { id: "form_page" + pageIndex, class: "form_page" }, this.getWidgets(widgets, pageIndex));
    };
    return FormPage;
}(Component));
var mapStateToProps = function (state, ownProps) {
    return Object.assign({
        widgets: state.form.get("widgets", List()),
        formItemValues: state.form.get("formItemValues", Map())
    }, ownProps);
};
export default connect(mapStateToProps, { updateWidget: updateWidget })(function (props) { return h(FormPage, __assign({}, props)); });
//# sourceMappingURL=FormPage.js.map