var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h } from "preact";
import translateDOMPositionXY from "../../vendor/translateDOMPositionXY";
import WidgetBase from "./WidgetBase";
import bind from "../../vendor/bind";
import { getPixelsPerPoint } from "../../utils/common";
var WidgetCheckBox = /** @class */ (function (_super) {
    __extends(WidgetCheckBox, _super);
    function WidgetCheckBox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WidgetCheckBox.prototype.onFocus = function () {
        this.context.updateWidget(this.props.data, { focus: true });
    };
    WidgetCheckBox.prototype.onBlur = function () {
        this.context.updateWidget(this.props.data, { focus: false });
    };
    WidgetCheckBox.prototype.onClick = function () {
        var _a = this.props, value = _a.value, data = _a.data;
        if (value != data.exportValue) {
            this.context.setItemValue(data.name, data.exportValue);
        }
        else {
            this.context.setItemValue(data.name, "off");
        }
    };
    WidgetCheckBox.prototype.render = function () {
        var _a = this.props, data = _a.data, value = _a.value, zoom = _a.zoom;
        var rect = this.context.rectToPage(data.pageindex, data.rect);
        var width = rect.right - rect.left;
        var height = Math.abs(rect.bottom - rect.top) + 2 * getPixelsPerPoint() * zoom;
        var style = {
            top: 0,
            position: "absolute",
            left: 0,
            width: width + "px",
            height: height + "px",
            cursor: "pointer",
            boxSizing: "border-box",
            background: data.focus ? "#fff" : WidgetBase.highLightColor,
            outline: 0
        };
        var imgStyle = {
            position: "absolute",
            top: "0",
            left: "0",
            width: width + "px"
        };
        translateDOMPositionXY(style, rect.left, rect.top - (1 * getPixelsPerPoint() * zoom));
        return (h("div", { "data-type": "checkbox", style: style, "data-name": data.name, tabIndex: 1, onFocus: this.onFocus, onBlur: this.onBlur, onClick: this.onClick },
            data.exportValue == value && h("img", { src: require("../../images/form/check_on.svg"), style: imgStyle }),
            data.exportValue !== value && h("img", { src: require("../../images/form/unchecked.svg"), style: imgStyle })));
    };
    __decorate([
        bind
    ], WidgetCheckBox.prototype, "onFocus", null);
    __decorate([
        bind
    ], WidgetCheckBox.prototype, "onBlur", null);
    __decorate([
        bind
    ], WidgetCheckBox.prototype, "onClick", null);
    return WidgetCheckBox;
}(WidgetBase));
export default WidgetCheckBox;
//# sourceMappingURL=WidgetCheckBox.js.map