var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h } from "preact";
import translateDOMPositionXY from "../../vendor/translateDOMPositionXY";
import WidgetBase from "./WidgetBase";
import bind from "../../vendor/bind";
var WidgetRadio = /** @class */ (function (_super) {
    __extends(WidgetRadio, _super);
    function WidgetRadio() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WidgetRadio.prototype.onFocus = function () {
        this.context.updateWidget(this.props.data, { focus: true });
    };
    WidgetRadio.prototype.onBlur = function () {
        this.context.updateWidget(this.props.data, { focus: false });
    };
    WidgetRadio.prototype.onClick = function () {
        var _a = this.props, value = _a.value, data = _a.data;
        if (value != data.exportValue) {
            this.context.setItemValue(data.name, data.exportValue);
        }
        else {
            this.context.setItemValue(data.name, "Off");
        }
    };
    WidgetRadio.prototype.render = function () {
        var _a = this.props, data = _a.data, value = _a.value;
        var rect = this.context.rectToPage(data.pageindex, data.rect);
        var width = rect.right - rect.left;
        var height = Math.abs(rect.bottom - rect.top);
        var style = {
            top: 0,
            position: "absolute",
            left: 0,
            width: width + "px",
            height: height + "px",
            boxSizing: "border-box",
            cursor: "pointer",
        };
        var bgStyle = {
            position: "absolute",
            width: width + "px",
            height: height + "px",
            cursor: "text",
            top: 1,
            zIndex: 4,
            pointerEvents: "none"
        };
        var size = Math.floor(Math.min(width, height)) - 1;
        var radioStyle = {
            position: "absolute",
            width: size,
            height: size,
            zIndex: 3,
            display: "flex",
            bottom: 0,
            right: 0,
            justifyContent: "center",
            alignItems: "center"
        };
        var ptSize = Math.floor(size / 2.5);
        var ptStyle = {
            width: ptSize,
            height: ptSize,
            background: "#000",
            borderRadius: ptSize / 2
        };
        translateDOMPositionXY(style, rect.left, rect.top);
        return (h("div", { "data-type": "radio", style: style, "data-name": data.name, tabIndex: 1, onFocus: this.onFocus, onBlur: this.onBlur, onClick: this.onClick },
            !data.focus && h("div", { class: "fwr-form-field-highlight", style: bgStyle }),
            data.exportValue == value && h("div", { style: radioStyle },
                h("div", { style: ptStyle }))));
    };
    __decorate([
        bind
    ], WidgetRadio.prototype, "onFocus", null);
    __decorate([
        bind
    ], WidgetRadio.prototype, "onBlur", null);
    __decorate([
        bind
    ], WidgetRadio.prototype, "onClick", null);
    return WidgetRadio;
}(WidgetBase));
export default WidgetRadio;
//# sourceMappingURL=WidgetRadio.js.map