import UserAgent_DEPRECATED from "../vendor/UserAgent_DEPRECATED";
import Spring from "../vendor/Spring";
import * as scriptLoad from 'script-load';
window.onload = function () {
    var _animationFrameID = null;
    var _scale = null;
    var _center = null;
    var _zoomStart = null;
    var spring;
    var distance;
    var curPos;
    var scrollStop;
    if (UserAgent_DEPRECATED.mobile()) {
        scriptLoad("./js/hammer.min.js", function () {
            var mc = new window.Hammer.Manager(document.getElementById("docViewer"));
            var pinch = new window.Hammer.Pinch({ threshold: 0.03 });
            var swipe = new window.Hammer.Swipe({ direction: window.Hammer.DIRECTION_VERTICAL });
            var tap = new window.Hammer.Tap({ event: 'singletap' });
            mc.add([pinch, swipe, tap]);
            mc.on("singletap", function () {
                scrollStop = true;
            });
            mc.on("swipedown", function (event) {
                if (Math.abs(event.velocity) < 0.10)
                    return;
                distance = -(event.distance + event.distance * Math.abs(event.velocity));
                spring = new Spring({ velocity: Math.abs(event.velocity), tension: 300, friction: 80 });
                curPos = 0;
                scrollStop = false;
                if (_animationFrameID == null) {
                    step();
                }
            });
            mc.on("swipeup", function (event) {
                if (Math.abs(event.velocity) < 0.10)
                    return;
                distance = (event.distance + event.distance * Math.abs(event.velocity));
                spring = new Spring({ velocity: event.velocity, tension: 300, friction: 80 });
                curPos = 0;
                scrollStop = false;
                if (_animationFrameID == null) {
                    step();
                }
            });
            mc.on("pinchstart", function (event) {
                //  _zoomStart = $(".docViewer").data("zoom")
                _center = event.center;
            });
            mc.on("pinchin", function (e) {
                if (_animationFrameID === null) {
                    _scale = e.scale;
                    _center = e.center;
                    _animationFrameID = requestAnimationFrame(zoomByPinch);
                }
                e.preventDefault();
            });
            mc.on("pinchout", function (e) {
                if (_animationFrameID === null) {
                    _scale = e.scale;
                    _center = e.center;
                    _animationFrameID = requestAnimationFrame(zoomByPinch);
                }
                e.preventDefault();
            });
        });
    }
    function step() {
        _animationFrameID = null;
        var p = spring.step();
        //  $(".docViewer").docview("wheel", (p - curPos) * distance / 100);
        curPos = p;
        if (spring.moving && !scrollStop) {
            _animationFrameID = window.requestAnimationFrame(step);
        }
    }
    function zoomByPinch() {
        _animationFrameID = null;
        // $(".docViewer").docview("zoomByPinch", [_scale * _zoomStart, _center]);
    }
};
//# sourceMappingURL=mobile.js.map