var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h, Component } from "preact";
import { connect } from 'preact-redux';
import i18next from "i18next";
import * as shallowEqual from "shallow-equals";
import bind from "../../vendor/bind";
import { List } from "immutable";
import * as actions from "../../sign/actions";
import { ActionCreators } from "redux-undo";
import EventListener from "../../vendor/EventListener";
import Point from "../../utils/point";
require("../../style/contextmenu.less");
var ContextMenu = /** @class */ (function (_super) {
    __extends(ContextMenu, _super);
    function ContextMenu() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ContextMenu.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !shallowEqual(this.state, nextState) || !shallowEqual(this.props, nextProps);
    };
    ContextMenu.prototype.componentDidMount = function () {
        this._eventKeydown = EventListener.listen(document.documentElement, 'keydown', this._onKeydown);
    };
    ContextMenu.prototype._onKeydown = function (event) {
        if (event.ctrlKey && event.keyCode == 90) {
            this.props.undo();
        }
        if (event.ctrlKey && event.keyCode == 89) {
            this.props.redo();
        }
        var activeSignField = this.props.activeSignField;
        if (activeSignField) {
            var pos = activeSignField.pos;
            //up
            if (event.keyCode == 38) {
                this.props.updateSignField(activeSignField, {
                    pos: new Point(pos.x, pos.y - 1)
                }, true);
            }
            //down
            if (event.keyCode == 40) {
                this.props.updateSignField(activeSignField, {
                    pos: new Point(pos.x, pos.y + 1)
                }, true);
            }
            //left
            if (event.keyCode == 37) {
                this.props.updateSignField(activeSignField, {
                    pos: new Point(pos.x - 1, pos.y)
                }, true);
            }
            //right
            if (event.keyCode == 39) {
                this.props.updateSignField(activeSignField, {
                    pos: new Point(pos.x + 1, pos.y)
                }, true);
            }
        }
    };
    ContextMenu.prototype.deleteSignField = function () {
        var activeSignField = this.props.activeSignField;
        if (activeSignField) {
            this.props.removeSignField(activeSignField, true);
        }
    };
    ContextMenu.prototype.render = function () {
        var _a = this.props, activeSignField = _a.activeSignField, undoable = _a.undoable, redoable = _a.redoable;
        var menuStyle = {
            position: "fixed"
        };
        return (h("div", { class: "context_menu", style: menuStyle, id: "sign_page_context_menu" },
            h("ul", { class: "dropdown-menu right-click-pop-up", role: "menu" },
                h("li", null,
                    h("button", { class: "item", type: "button", onClick: this.props.undo, disabled: !undoable },
                        h("span", null, i18next.t("Undo")),
                        h("span", { class: "item_ext" },
                            h("span", null, "(Ctrl+Z)")))),
                h("li", null,
                    h("button", { class: "item", type: "button", onClick: this.props.redo, disabled: !redoable },
                        h("span", null, i18next.t("Redo")),
                        h("span", { class: "item_ext" },
                            h("span", null, "(Ctrl+Y)")))),
                h("li", { class: "item_spliter" }),
                h("li", null,
                    h("button", { class: "item", type: "button", onClick: this.deleteSignField, disabled: !activeSignField },
                        h("span", null, i18next.t("Delete")),
                        h("span", { class: "item_ext" },
                            h("span", null, "(Delete)")))))));
    };
    __decorate([
        bind
    ], ContextMenu.prototype, "_onKeydown", null);
    __decorate([
        bind
    ], ContextMenu.prototype, "deleteSignField", null);
    return ContextMenu;
}(Component));
var mapStateToProps = function (state) {
    var activeSignFields = state.sign.present.get("fields", List()).filter(function (field) { return field.active; }).toList();
    return {
        undoable: state.sign.past.length > 0,
        redoable: state.sign.future.length > 0,
        activeSignField: activeSignFields.size > 0 ? activeSignFields.get(0) : null
    };
};
export default connect(mapStateToProps, {
    removeSignField: actions.removeSignField,
    updateSignField: actions.updateSignField,
    undo: ActionCreators.undo,
    redo: ActionCreators.redo
})(function (props) { return h(ContextMenu, __assign({}, props)); });
//# sourceMappingURL=ContextMenu.js.map