var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { h, Component } from "preact";
import { connect } from 'preact-redux';
import i18next from "i18next";
import * as shallowEqual from "shallow-equals";
import bind from "../../vendor/bind";
import { Map } from "immutable";
import AnimateExecutor from "../../vendor/AnimateExecutor";
import { SignType } from "../../sign/models";
import { setCurSignField } from "../../sign/actions";
import sortSignField from "./sortSignField";
import UserAgent from "../../vendor/UserAgent_DEPRECATED";
var NavigateBtn = /** @class */ (function (_super) {
    __extends(NavigateBtn, _super);
    function NavigateBtn(props) {
        var _this = _super.call(this, props) || this;
        _this._animateExecutor = new AnimateExecutor();
        _this.state = {
            lastIndex: -1,
            top: 40,
            title: i18next.t("Start"),
            mouseEnter: false
        };
        return _this;
    }
    NavigateBtn.prototype.onSigned = function (signId) {
        var _a = this.props, allFields = _a.allFields, curSignField = _a.curSignField;
        if (curSignField && curSignField.id == signId) {
            if (!this.isFinished(allFields.toList())) {
                this.setState({ title: i18next.t("Next") });
            }
        }
    };
    NavigateBtn.prototype.componentDidMount = function () {
        this.context.webpdf.on("SIGNED", this.onSigned);
        this.context.webpdf.on("TO_NEXT_SIGNFIELD", this.toNextSignField);
    };
    NavigateBtn.prototype.isFinished = function (fields) {
        return fields.filter(function (field) { return !field.signed; }).size == 0;
    };
    NavigateBtn.prototype.componentWillReceiveProps = function (nextProps) {
        if (!UserAgent.mobile()) {
            var selectedRecipient = nextProps.selectedRecipient, allFields = nextProps.allFields, curSignField = nextProps.curSignField;
            if (nextProps.scrollY != this.props.scrollY && curSignField) {
                this.setState({ title: i18next.t("Next") });
                this.props.setCurSignField(null);
            }
        }
    };
    NavigateBtn.prototype.componentWillUnmount = function () {
        this.context.webpdf.removeListener("SIGNED", this.onSigned);
        this.context.webpdf.removeListener("TO_NEXT_SIGNFIELD", this.toNextSignField);
    };
    NavigateBtn.prototype.calcTop = function () {
        return this.state.top - 21;
    };
    NavigateBtn.prototype.onMouseEnter = function () {
        this.setState({ mouseEnter: true });
    };
    NavigateBtn.prototype.onMouseLeave = function () {
        this.setState({ mouseEnter: false });
    };
    NavigateBtn.prototype.getTitle = function (type) {
        return type == SignType.date_signed ? "date" : type;
    };
    NavigateBtn.prototype.onClick = function () {
        this.toNextSignField();
    };
    NavigateBtn.prototype.toNextSignField = function (direct) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var allFields, lastIndex, index, fields, field, i, ptPage, ptDoc, scrollY_1, top_1, originTop_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        allFields = this.props.allFields;
                        lastIndex = this.state.lastIndex;
                        index = direct != "last" ? lastIndex + 1 : lastIndex - 1;
                        fields = allFields.toList().sort(sortSignField);
                        field = null;
                        for (i = 0; i < fields.size; i++) {
                            if (index > fields.size - 1) {
                                index = 0;
                            }
                            if (index < 0) {
                                index = fields.size - 1;
                            }
                            field = fields.get(index);
                            if (!field.signed) {
                                break;
                            }
                            else {
                                index = direct != "last" ? index + 1 : index - 1;
                            }
                        }
                        if (!(field && !field.signed)) return [3 /*break*/, 2];
                        ptPage = this.context.pdfToPage(field.pageIndex, field.pos);
                        ptDoc = this.context.pagePtToDoc(field.pageIndex, ptPage);
                        return [4 /*yield*/, this.context.scrollTo(ptDoc)];
                    case 1:
                        scrollY_1 = _a.sent();
                        top_1 = ptDoc.y - scrollY_1 + field.size.height / 2;
                        originTop_1 = this.state.top;
                        this._animateExecutor.execute(top_1 - originTop_1, function (delta) {
                            _this.props.setCurSignField(field);
                            _this.setState({ lastIndex: index, top: originTop_1 + delta, title: i18next.t("Sign") });
                        });
                        return [3 /*break*/, 3];
                    case 2:
                        this.props.setCurSignField(null);
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    NavigateBtn.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !shallowEqual(this.state, nextState) || !shallowEqual(this.props, nextProps);
    };
    NavigateBtn.prototype.render = function (props) {
        var leftLength = 79;
        var rightLength = 42;
        var style = {
            position: "absolute",
            left: (props.docViewWidth - this.context.getPageWidth()) / 2 - leftLength,
            top: this.calcTop(),
            height: rightLength,
            width: leftLength + rightLength,
        };
        var allFields = this.props.allFields;
        var _a = this.state, mouseEnter = _a.mouseEnter, title = _a.title;
        var color = mouseEnter ? "rgba(74, 143, 215, 0.9)" : "rgba(74, 143, 215, 0.7)";
        if (!this.isFinished(allFields.toList())) {
            return (h("div", { class: "autonav-button-wrapper", style: style, onMouseEnter: this.onMouseEnter, onMouseLeave: this.onMouseLeave, onClick: this.onClick },
                h("div", { class: "nav-btn", style: { background: color, width: leftLength } }, title),
                h("div", { class: "btn-caret-right", style: { borderLeftColor: color } })));
        }
        else {
            return null;
        }
    };
    __decorate([
        bind
    ], NavigateBtn.prototype, "onSigned", null);
    __decorate([
        bind
    ], NavigateBtn.prototype, "onMouseEnter", null);
    __decorate([
        bind
    ], NavigateBtn.prototype, "onMouseLeave", null);
    __decorate([
        bind
    ], NavigateBtn.prototype, "onClick", null);
    __decorate([
        bind
    ], NavigateBtn.prototype, "toNextSignField", null);
    return NavigateBtn;
}(Component));
export { NavigateBtn };
var mapStateToProps = function (state, ownProps) {
    return Object.assign({
        allFields: state.sign.present.get("fields", Map()),
        curSignField: state.sign.present.get("curSignField", null)
    }, ownProps);
};
export default connect(mapStateToProps, { setCurSignField: setCurSignField })(function (props) { return h(NavigateBtn, __assign({}, props)); });
//# sourceMappingURL=NavigateBtn.js.map