var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h, Component } from "preact";
import DropdownMenu from "../../components/DropdownMenu";
import * as classNames from 'classnames';
import i18next from "i18next";
import bind from "../../vendor/bind";
import RecipientColorScheme from "../../utils/RecipientColorScheme";
import * as shallowEqual from "shallow-equals";
require("../../style/dropdown_menu.less");
var RecipientSelector = /** @class */ (function (_super) {
    __extends(RecipientSelector, _super);
    function RecipientSelector(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            showMenu: false
        };
        return _this;
    }
    RecipientSelector.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !shallowEqual(this.state, nextState) || !shallowEqual(this.props, nextProps);
    };
    RecipientSelector.prototype.openMenu = function () {
        this.setState({ showMenu: true });
    };
    RecipientSelector.prototype.setSelectedRecipient = function (recipient) {
        this.props.setSelectedRecipient(recipient);
        this.setState({ showMenu: false });
    };
    RecipientSelector.prototype.getRecipientSwatchStyle = function (recipient) {
        return RecipientColorScheme(this.props.recipients, recipient.signId);
    };
    RecipientSelector.prototype.isSelected = function (recipient) {
        return this.props.selectedRecipient.signerId == recipient.signerId;
    };
    RecipientSelector.prototype.render = function () {
        var _this = this;
        var showMenu = this.state.showMenu;
        var _a = this.props, recipients = _a.recipients, selectedRecipient = _a.selectedRecipient;
        return (h("div", null,
            h("div", null, i18next.t("Signers") + ":"),
            selectedRecipient &&
                h("button", { id: "btnRecipients", type: "button", class: "btn btn-select btn-utility btn-recipients btn-inline u-ellipsis", onClick: this.openMenu },
                    h("span", { class: classNames("swatch swatch-sm swatch-round swatch-recipient"), style: this.getRecipientSwatchStyle(selectedRecipient) }),
                    h("span", null, selectedRecipient.name || selectedRecipient.role)),
            h(DropdownMenu, { class: "select-menu", show: showMenu, onClose: function () { return _this.setState({ showMenu: false }); } },
                h("ul", { role: "menu" }, recipients.map(function (recipient) { return (h("li", { key: recipient.signerId },
                    h("button", { class: classNames("item btn-inline", { on: _this.isSelected(recipient) }), onClick: function () { return _this.setSelectedRecipient(recipient); } },
                        h("span", { style: { width: "26px" } }, _this.isSelected(recipient) && h("img", { src: require("../../images/check.png") })),
                        h("span", { class: classNames("swatch swatch-round swatch-recipient"), style: _this.getRecipientSwatchStyle(recipient) }),
                        h("span", null, recipient.name || recipient.role)))); })))));
    };
    __decorate([
        bind
    ], RecipientSelector.prototype, "openMenu", null);
    return RecipientSelector;
}(Component));
export default RecipientSelector;
//# sourceMappingURL=RecipientSelector.js.map