var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { h, Component } from "preact";
import { connect } from 'preact-redux';
import { Map } from "immutable";
import * as cuid from "cuid";
import * as closest from "closest";
import { addSignField, removeSignField, updateSignField, activeSignField, } from "../../sign/actions";
import SignField from "./SignField";
import DOMMouseMoveTracker from "../../vendor/DOMMouseMoveTracker";
import getEventClientPos from "../../vendor/getPtClientPos";
import Point from "../../utils/point";
import Size from "../../utils/size";
import ContextMenuTrigger from "../ContextMenuTrigger";
import { ActionCreators } from "redux-undo";
import { SignType } from "../../sign/models";
import * as style from "dom-helpers/style";
import { adjustPosition, getPageElement } from "../../utils/common";
import bind from "../../vendor/bind";
import EventListener from '../../vendor/EventListener';
import UserAgent from "../../vendor/UserAgent_DEPRECATED";
export var floatFieldId = "float";
// const LoadableComponent = Loadable({
//   loader: () => import('./my-component'),
//   loading: Loading,
// });
// const AddSignatureModal = Loadable({
//   loader: () => import('../AddSignatureModal'),
//   loading: "div",
// });
var SignPage = /** @class */ (function (_super) {
    __extends(SignPage, _super);
    function SignPage(props) {
        var _this = _super.call(this, props) || this;
        var allFields = props.allFields, pageIndex = props.pageIndex;
        _this.state = {
            fields: allFields.filter(function (field) { return field.pageIndex == pageIndex; }).toList()
        };
        return _this;
    }
    SignPage.prototype.getChildContext = function () {
        return {
            recipientColorScheme: this.props.getRecipientColorScheme,
            updateSignField: this.props.updateSignField,
            activeSignField: this.props.activeSignField,
            signFieldDragStop: this.signFieldDragStop,
            signFieldDragStart: this.signFieldDragStart,
            getSignFieldIcon: this.props.getSignFieldIcon,
            startSign: this.startSign
        };
    };
    SignPage.prototype.componentWillReceiveProps = function (nextProps) {
        var allFields = nextProps.allFields, pageIndex = nextProps.pageIndex;
        if (this.props.allFields !== allFields) {
            this.setState({
                fields: allFields.filter(function (field) { return field.pageIndex == pageIndex; }).toList()
            });
        }
    };
    SignPage.prototype.componentDidMount = function () {
        this._mouseMoveTracker = new DOMMouseMoveTracker(this._onMouseMove, this._onMouseMoveEnd, document.documentElement);
        EventListener.listen(this.base, "custom_enter", this.handlerMouseEnter);
        EventListener.listen(this.base, "custom_mouseup", this.handlerMouseUp);
        // if (this.props.pageIndex == 0) {
        //   this.props.addSignField({
        //     type: "signature",
        //     recipient: this.props.getSelectedRecipient(),
        //     id: cuid(),
        //     active: false,
        //     pageIndex: this.props.pageIndex,
        //     size: this.getSignFieldDefaultSize(),
        //     pos: this.context.ptToPDF(new Point(100, 100))
        //   })
        //   this.props.addSignField({
        //     type: "signature",
        //     recipient: this.props.getSelectedRecipient(),
        //     id: cuid(),
        //     active: false,
        //     pageIndex: this.props.pageIndex,
        //     size: this.getSignFieldDefaultSize(),
        //     pos: new Point(100, 300)
        //   })
        // }
        // if (this.props.pageIndex == 0) {
        //   setTimeout(() => showModal(<AddSignatureModal setSign={this.setSign} />), 0)
        // }
    };
    SignPage.prototype.componentWillUnmount = function () {
        this._mouseMoveTracker.releaseMouseMoves();
    };
    SignPage.prototype.getSignFieldDefaultSize = function (fieldType) {
        if (fieldType == SignType.signature) {
            return new Size(120, 50);
        }
        return new Size(100, 50);
    };
    SignPage.prototype.getFloatFieldId = function () {
        return floatFieldId + this.props.pageIndex;
    };
    SignPage.prototype.startSign = function (signFieldMeta) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var signData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.props.getSignDatas(signFieldMeta)];
                    case 1:
                        signData = _a.sent();
                        this.props.updateSignField(signFieldMeta, { signed: true, signData: signData }, false);
                        setTimeout(function () {
                            _this.context.webpdf.emit("SIGNED", signFieldMeta.id);
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    SignPage.prototype._onMouseMove = function (deltaX, deltaY, _a) {
        var clientX = _a.clientX, clientY = _a.clientY;
        var _b = this.props, zoom = _b.zoom, pageIndex = _b.pageIndex;
        this.props.updateSignField({ id: this.getFloatFieldId() }, { pos: this.context.ptToPDF(pageIndex, new Point(clientX, clientY).ScreenToElement(this.base)) }, false);
    };
    SignPage.prototype._onMouseMoveEnd = function (clientX, clientY) {
        var pageIndex = this.props.pageIndex;
        this.props.updateSignField({ id: this.getFloatFieldId() }, { pos: this.context.ptToPDF(pageIndex, new Point(clientX, clientY).ScreenToElement(this.base)) }, true);
    };
    SignPage.prototype.onMouseEnter = function (event) {
        var pageIndex = this.props.pageIndex;
        this.props.onMouseEnter(event);
        var fieldType = this.props.getSelectedFieldType();
        if (fieldType) {
            var pos = getEventClientPos(event);
            style(getPageElement(this.props.pageIndex), "z-index", 1);
            this.props.addSignField({
                signerId: this.props.getSelectedRecipient().signerId,
                pageIndex: this.props.pageIndex,
                type: fieldType,
                id: this.getFloatFieldId(),
                pos: this.context.ptToPDF(pageIndex, new Point(pos.clientX, pos.clientY).ScreenToElement(this.base)),
                size: this.getSignFieldDefaultSize(fieldType)
            }, false);
            this._mouseMoveTracker.captureMouseMoves(event);
        }
    };
    SignPage.prototype.handlerMouseEnter = function (event) {
        var pageIndex = this.props.pageIndex;
        this.props.onMouseEnter(event);
        var fieldType = this.props.getSelectedFieldType();
        if (fieldType) {
            var pos = event.detail;
            style(getPageElement(this.props.pageIndex), "z-index", 1);
            this.props.addSignField({
                signerId: this.props.getSelectedRecipient().signerId,
                pageIndex: this.props.pageIndex,
                type: fieldType,
                id: this.getFloatFieldId(),
                pos: this.context.ptToPDF(pageIndex, new Point(pos.clientX, pos.clientY).ScreenToElement(this.base)),
                size: this.getSignFieldDefaultSize(fieldType)
            }, false);
        }
    };
    SignPage.prototype.onMouseLeave = function (event) {
        var fieldType = this.props.getSelectedFieldType();
        if (fieldType) {
            this.props.removeSignField({ id: this.getFloatFieldId() }, false);
            this._mouseMoveTracker.captureMouseMoves(event);
            style(getPageElement(this.props.pageIndex), "z-index", 0);
        }
        this.props.onMouseLeave(event);
    };
    SignPage.prototype.onMouseDown_TouchStart = function (event) {
        console.log("onMouseDown_TouchStart", event.type);
        var pageIndex = this.props.pageIndex;
        var fieldType = this.props.getSelectedFieldType();
        if (fieldType) {
            var pos = getEventClientPos(event);
            var scrollTop = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
            this.addSignField(pageIndex, new Point(pos.clientX, pos.clientY + scrollTop).ScreenToElement(this.base), fieldType);
            this._mouseMoveTracker.releaseMouseMoves();
            event.stopPropagation();
        }
        if (closest(event.target, ".sign_field", true)) {
            event.stopPropagation();
        }
    };
    // @bind
    // onTouchMove(event) {
    //   if (closest(event.target, ".sign_field", true)) {
    //     event.stopPropagation();
    //   }
    // }
    SignPage.prototype.onMouseUp = function (event) {
        var pageIndex = this.props.pageIndex;
        var fieldType = this.props.getSelectedFieldType();
        if (fieldType) {
            var pos = getEventClientPos(event);
            this.addSignField(pageIndex, new Point(pos.clientX, pos.clientY).ScreenToElement(this.base), fieldType);
            this._mouseMoveTracker.releaseMouseMoves();
            event.stopPropagation();
        }
    };
    SignPage.prototype.handlerMouseUp = function (event) {
        var pageIndex = this.props.pageIndex;
        var fieldType = this.props.getSelectedFieldType();
        if (fieldType) {
            var pos = event.detail;
            this.addSignField(pageIndex, new Point(pos.clientX, pos.clientY).ScreenToElement(this.base), fieldType);
        }
    };
    SignPage.prototype.addSignField = function (pageIndex, pagePt, fieldType) {
        var node = document.getElementById(this.getFloatFieldId());
        var pos = adjustPosition(pagePt, node, this.getSignPage(this.props.pageIndex), { bottom: 20 });
        this.props.removeSignField({ id: this.getFloatFieldId() }, false);
        this.props.addSignField({
            signerId: this.props.getSelectedRecipient().signerId,
            type: fieldType,
            pageIndex: pageIndex,
            id: cuid(),
            active: true,
            pos: this.context.ptToPDF(pageIndex, pos),
            size: this.getSignFieldDefaultSize(fieldType),
        }, true);
        this.props.onAddSignField();
    };
    SignPage.prototype.signFieldDragStart = function (event, dragData) {
        console.log("dragStart", dragData.x, dragData.y);
        this._lastX = dragData.x;
        this._lastY = dragData.y;
        style(getPageElement(this.props.pageIndex), "z-index", 1);
    };
    SignPage.prototype.getSignPage = function (pageIndex) {
        return document.getElementById("sign_page" + pageIndex);
    };
    SignPage.prototype.signFieldDragStop = function (fieldMeta, dragData) {
        if (Math.abs(dragData.x - this._lastX) > 3 || Math.abs(dragData.y - this._lastY) > 3) {
            var pageIndex = this.props.pageIndex;
            var docPt = this.context.pagePtToDoc(pageIndex, new Point(dragData));
            var _pageIndex = this.context.getPageByDocPt(docPt);
            if (pageIndex != _pageIndex) {
                var pagePt = this.context.docPtToPage(_pageIndex, docPt);
                var pos = adjustPosition(pagePt, dragData.node, this.getSignPage(pageIndex), { bottom: 20 });
                this.props.updateSignField(fieldMeta, {
                    pageIndex: _pageIndex,
                    pos: this.context.ptToPDF(_pageIndex, pos)
                }, true);
            }
            else {
                var element = dragData.node;
                var pos = adjustPosition(dragData, dragData.node, this.base, { bottom: 20 });
                this.props.updateSignField(fieldMeta, { pos: this.context.ptToPDF(pageIndex, pos) }, true);
            }
            style(getPageElement(pageIndex), "z-index", 0);
        }
    };
    SignPage.prototype.render = function () {
        var _this = this;
        var _a = this.props, pageIndex = _a.pageIndex, zoom = _a.zoom, signing = _a.signing, curSignField = _a.curSignField;
        if (!signing) {
            return (h(ContextMenuTrigger, { target: "#sign_page_context_menu", disable: UserAgent.mobile(), holdToDisplay: 1000 },
                h("div", { onTouchStart: this.onMouseDown_TouchStart, onTouchEnd: this.onMouseLeave, onMouseEnter: this.onMouseEnter, onMouseLeave: this.onMouseLeave, onMouseDown: this.onMouseDown_TouchStart, onMouseUp: this.onMouseUp, id: "sign_page" + pageIndex, class: "sign_page" }, this.state.fields.map(function (field) { return h(SignField, { key: field.id, zoom: zoom, curSignField: false, signing: signing, rndable: field.id != _this.getFloatFieldId() && !signing, fieldMeta: field }); }).toArray())));
        }
        else {
            return (h("div", { onMouseEnter: this.onMouseEnter, onMouseLeave: this.onMouseLeave, onMouseDown: this.onMouseDown_TouchStart, onMouseUp: this.onMouseUp, id: "sign_page" + pageIndex, class: "sign_page" }, this.state.fields.map(function (field) { return h(SignField, { key: field.id, zoom: zoom, signing: signing, curSignField: curSignField && curSignField.id == field.id, rndable: field.id != _this.getFloatFieldId() && !signing, fieldMeta: field }); }).toArray()));
        }
    };
    __decorate([
        bind
    ], SignPage.prototype, "startSign", null);
    __decorate([
        bind
    ], SignPage.prototype, "_onMouseMove", null);
    __decorate([
        bind
    ], SignPage.prototype, "_onMouseMoveEnd", null);
    __decorate([
        bind
    ], SignPage.prototype, "onMouseEnter", null);
    __decorate([
        bind
    ], SignPage.prototype, "handlerMouseEnter", null);
    __decorate([
        bind
    ], SignPage.prototype, "onMouseLeave", null);
    __decorate([
        bind
    ], SignPage.prototype, "onMouseDown_TouchStart", null);
    __decorate([
        bind
    ], SignPage.prototype, "onMouseUp", null);
    __decorate([
        bind
    ], SignPage.prototype, "handlerMouseUp", null);
    __decorate([
        bind
    ], SignPage.prototype, "signFieldDragStart", null);
    __decorate([
        bind
    ], SignPage.prototype, "signFieldDragStop", null);
    return SignPage;
}(Component));
var mapStateToProps = function (state, ownProps) {
    return Object.assign({
        allFields: state.sign.present.get("fields", Map()),
        curSignField: state.sign.present.get("curSignField", null)
    }, ownProps);
};
export default connect(mapStateToProps, {
    addSignField: addSignField,
    removeSignField: removeSignField,
    updateSignField: updateSignField,
    activeSignField: activeSignField,
    undo: ActionCreators.undo,
    redo: ActionCreators.redo
})(function (props) { return h(SignPage, __assign({}, props)); });
//# sourceMappingURL=SignPage.js.map