import { Map, List, fromJS } from "immutable";
import { set_widgets, SET_FORM_ITEM_VALUES, SET_ITEM_VALUE, UPDATE_WIDGET } from './const';
export default function reducer(state, action) {
    if (state === void 0) { state = Map(); }
    switch (action.type) {
        case set_widgets: {
            return state.set("widgets", List(action.widgets));
        }
        case SET_FORM_ITEM_VALUES:
            {
                return state.set("formItemValues", fromJS(action.formItemValues));
            }
        case SET_ITEM_VALUE:
            {
                var itemName = action.itemName, itemValue = action.itemValue;
                return state.setIn(["formItemValues", itemName, "value"], itemValue);
            }
        case UPDATE_WIDGET:
            {
                var widget_1 = action.widget, props = action.props;
                var widgets = state.get("widgets", List());
                var index = widgets.findIndex(function (_widget) { return _widget.id == widget_1.id; });
                if (index != -1) {
                    return state.setIn(["widgets", index], Object.assign({}, widgets.get(index), props));
                }
                return state;
            }
        default:
            break;
    }
    return state;
}
//# sourceMappingURL=FormPluginReducer.js.map