import * as cuid from "cuid";
export var Alignment;
(function (Alignment) {
    Alignment[Alignment["AlignmentLeft"] = 0] = "AlignmentLeft";
    Alignment[Alignment["AlignmentCenter"] = 1] = "AlignmentCenter";
    Alignment[Alignment["AlignmentRight"] = 2] = "AlignmentRight";
})(Alignment || (Alignment = {}));
export var WidgetFlags;
(function (WidgetFlags) {
    WidgetFlags[WidgetFlags["Invisible"] = 1] = "Invisible";
    WidgetFlags[WidgetFlags["Hidden"] = 2] = "Hidden";
    WidgetFlags[WidgetFlags["Print"] = 4] = "Print";
    WidgetFlags[WidgetFlags["NoZoom"] = 8] = "NoZoom";
    WidgetFlags[WidgetFlags["NoRotate"] = 16] = "NoRotate";
    WidgetFlags[WidgetFlags["NoView"] = 32] = "NoView";
    WidgetFlags[WidgetFlags["ReadOnly"] = 64] = "ReadOnly";
    WidgetFlags[WidgetFlags["Locked"] = 128] = "Locked";
    WidgetFlags[WidgetFlags["ToggleNoView"] = 256] = "ToggleNoView";
    WidgetFlags[WidgetFlags["LockedContents"] = 512] = "LockedContents";
})(WidgetFlags || (WidgetFlags = {}));
export var ActionTrigger;
(function (ActionTrigger) {
    ActionTrigger[ActionTrigger["TriggerPageOpened"] = 0] = "TriggerPageOpened";
    ActionTrigger[ActionTrigger["TriggerFieldKeyStroke"] = 7] = "TriggerFieldKeyStroke";
    ActionTrigger[ActionTrigger["TriggerFieldWillFormat"] = 8] = "TriggerFieldWillFormat";
    ActionTrigger[ActionTrigger["TriggerFieldValueChanged"] = 9] = "TriggerFieldValueChanged";
    ActionTrigger[ActionTrigger["TriggerFieldRecalculateValue"] = 10] = "TriggerFieldRecalculateValue";
})(ActionTrigger || (ActionTrigger = {}));
export var FieldFlags;
(function (FieldFlags) {
    FieldFlags[FieldFlags["FlagReadOnly"] = 1] = "FlagReadOnly";
    FieldFlags[FieldFlags["FlagTextMultiline"] = 256] = "FlagTextMultiline";
})(FieldFlags || (FieldFlags = {}));
var Widget = /** @class */ (function () {
    function Widget(params) {
        this.formatters = [];
        this.validater = [];
        this.id = cuid();
        Object.assign(this, params);
    }
    return Widget;
}());
export { Widget };
export var FormWidgetType;
(function (FormWidgetType) {
    FormWidgetType[FormWidgetType["Unknown"] = 0] = "Unknown";
    FormWidgetType[FormWidgetType["PushButton"] = 1] = "PushButton";
    FormWidgetType[FormWidgetType["RadioButton"] = 3] = "RadioButton";
    FormWidgetType[FormWidgetType["CheckBox"] = 2] = "CheckBox";
    FormWidgetType[FormWidgetType["Text"] = 6] = "Text";
    FormWidgetType[FormWidgetType["RichText"] = 5] = "RichText";
    FormWidgetType[FormWidgetType["ListBox"] = 7] = "ListBox";
    FormWidgetType[FormWidgetType["ComboBox"] = 8] = "ComboBox";
    FormWidgetType[FormWidgetType["Sign"] = 9] = "Sign"; // digital signature.
})(FormWidgetType || (FormWidgetType = {}));
//# sourceMappingURL=models.js.map