import { save_token, delete_token, save_user, save_docInfo, delete_user, set_signers, update_signer, order_signers, save_ticket, set_sign_info } from "../actions/const";
import { Map, List } from "immutable";
import * as cuid from "cuid";
export default function appReducer(state, action) {
    if (state === void 0) { state = Map(); }
    switch (action.type) {
        case save_token:
            {
                return state.set("accessToken", action.accessToken);
            }
        case delete_token:
            {
                return state.set("accessToken", null);
            }
        case save_user:
            {
                return state.set("userInfo", action.userInfo);
            }
        case save_docInfo:
            {
                return state.set("docInfo", action.docInfo);
            }
        case delete_user:
            {
                return state.set("userInfo", null);
            }
        case save_ticket:
            {
                return state.set("ticket", action.ticket);
            }
        case set_signers:
            {
                var signers = action.signers;
                if (signers.length == 0) {
                    signers.push({ id: cuid(), name: "", email: "", order: 0 });
                }
                return state.set("signers", List(signers));
            }
        case update_signer:
            {
                var signer_1 = action.signer, props_1 = action.props;
                return state.update("signers", List(), function (_signers) {
                    var index = _signers.findIndex(function (_signer) { return signer_1.id == _signer.id; });
                    if (index == -1) {
                        return _signers;
                    }
                    else {
                        return _signers.update(index, function (signer) { return Object.assign({}, signer, props_1); });
                    }
                });
            }
        case order_signers:
            {
                var order_1 = action.order;
                var signers = state.get("signers", List()).toJS();
                signers.forEach(function (signer) {
                    var index = order_1.findIndex(function (item) { return item.id == signer.id; });
                    if (index != -1) {
                        signer.order = index;
                    }
                });
                return state.set("signers", List(signers));
            }
        case set_sign_info:
            {
                return state.set("signInfo", action.signInfo);
            }
        default:
            return state;
    }
}
//# sourceMappingURL=appReducer.js.map