import { show_float_icon, set_mouse_pos, mouse_in_page, set_selected_field_type, set_selected_recipient, set_sign_data, set_recipients } from "../actions/const";
import * as cuid from "cuid";
var recipients = [
    { signId: cuid(), name: "wenqi_zheng1", email: "wenqi_zheng!@foxitsoftware.com" },
    { signId: cuid(), name: "wenqi_zheng", email: "wenqi_zheng!@foxitsoftware.cn" }
];
var defaultState = { showFloatIcon: false, mousePos: {}, recipients: recipients, selectedRecipient: recipients[0], signDatas: {} };
export default function reducer(state, action) {
    if (state === void 0) { state = defaultState; }
    switch (action.type) {
        case show_float_icon:
            return Object.assign({}, state, { showFloatIcon: action.show });
        case set_mouse_pos:
            return Object.assign({}, state, { mousePos: action.mousePos });
        case mouse_in_page:
            return Object.assign({}, state, { inPage: action.inPage });
        case set_selected_field_type:
            return Object.assign({}, state, { selectedFieldType: action.selectedFieldType });
        case set_selected_recipient:
            return Object.assign({}, state, { selectedRecipient: action.selectedRecipient });
        case set_recipients:
            return Object.assign({}, state, { recipients: action.recipients, selectedRecipient: action.recipients[0] });
        case set_sign_data:
            {
                var signData = action.signData;
                var signType = action.signType;
                var signDatas = state.signDatas;
                signDatas[signType] = signData;
                return Object.assign({}, state, { signDatas: signDatas });
            }
        default:
            break;
    }
    return state;
}
//# sourceMappingURL=signReducer.js.map