import { Map } from "immutable";
import { add_sign_field, remove_sign_field, update_sign_field, active_sign_field, set_cur_sign_field } from "./const";
import undoable from "../vendor/redux-undo";
function reducer(state, action) {
    if (state === void 0) { state = Map(); }
    switch (action.type) {
        case add_sign_field:
            {
                var signField_1 = action.signField;
                var activeFields_1 = state.get("fields", Map()).filter(function (field) { return field.active; });
                return state.update("fields", Map(), function (fields) {
                    return fields.withMutations(function (_fields) {
                        activeFields_1.forEach(function (aField) {
                            _fields.update(aField.id, function (field) { return Object.assign({}, field, { active: false }); });
                        });
                        _fields.set(signField_1.id, signField_1);
                    });
                });
            }
        case remove_sign_field:
            {
                var signField_2 = action.signField;
                ;
                return state.update("fields", Map(), function (fields) { return fields.delete(signField_2.id); });
            }
        case update_sign_field:
            {
                var signField = action.signField;
                if (state.getIn(["fields", signField.id])) {
                    return state.updateIn(["fields", signField.id], function (field) {
                        return Object.assign({}, field, action.props);
                    });
                }
                return state;
            }
        case active_sign_field:
            {
                var signField_3 = action.signField;
                var activeFields_2 = state.get("fields").filter(function (field) { return field.active; });
                return state.update("fields", function (fields) {
                    return fields.withMutations(function (_fields) {
                        activeFields_2.forEach(function (aField) {
                            _fields.update(aField.id, function (field) { return Object.assign({}, field, { active: false }); });
                        });
                        _fields.update(signField_3.id, function (field) { return Object.assign({}, field, { active: true }); });
                    });
                });
            }
        case set_cur_sign_field:
            {
                var signField = action.signField;
                return state.set("curSignField", signField);
            }
        default:
            break;
    }
    return state;
}
function undoFilter(action, currState, prevState) {
    if ([add_sign_field, remove_sign_field, update_sign_field].indexOf(action.type) != -1) {
        console.log("persistent", action.persistent);
        return action.persistent;
    }
    return false;
}
export default undoable(reducer, {
    limit: 50,
    filter: undoFilter
});
//# sourceMappingURL=SignPluginReducer.js.map