import { add_sign_field, remove_sign_field, update_sign_field, active_sign_field, set_cur_sign_field, mouse_in_page, set_selected_field_type, show_float_icon, set_selected_recipient } from "./const";
import Point from "../utils/point";
import Size from "../utils/size";
export function addSignField(signField, persistent) {
    if (!(signField.pos instanceof Point)) {
        signField.pos = new Point(signField.pos);
    }
    if (!(signField.size instanceof Size)) {
        signField.size = new Size(signField.size);
    }
    return { type: add_sign_field, signField: signField, persistent: persistent };
}
export function setMouseInPage(inPage) {
    return { type: mouse_in_page, inPage: inPage };
}
export function removeSignField(signField, persistent) {
    return { type: remove_sign_field, signField: signField, persistent: persistent };
}
export function updateSignField(signField, props, persistent) {
    return { type: update_sign_field, signField: signField, props: props, persistent: persistent };
}
export function activeSignField(signField) {
    return { type: active_sign_field, signField: signField };
}
export function setSelectedFieldType(selectedFieldType) {
    return { type: set_selected_field_type, selectedFieldType: selectedFieldType };
}
export function setCurSignField(signField) {
    return { type: set_cur_sign_field, signField: signField };
}
export function showFloatIcon(show) {
    return { type: show_float_icon, show: show };
}
export function setSelectedRecipient(selectedRecipient) {
    return { type: set_selected_recipient, selectedRecipient: selectedRecipient };
}
//# sourceMappingURL=actions.js.map