var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { h, Component } from "preact";
import RecipientSelector from "./RecipientSelector";
import DOMMouseMoveTracker from "../vendor/DOMMouseMoveTracker";
import getEventClientPos from "../vendor/getPtClientPos";
import bind from "../vendor/bind";
import { connect } from "preact-redux";
import AsyncRetryExecutor from "../vendor/AsyncRetryExecutor";
import { getSignInfo, getDocManifestInfo } from "../API";
import * as actions from "../actions";
import * as selector from "../selector";
import RecipientColorScheme from "../utils/RecipientColorScheme";
import classNames from "classnames";
import UserAgent from "../vendor/UserAgent_DEPRECATED";
import AddFieldsPanel from "../components/sign/AddFieldsPanel";
import * as classHelper from "dom-helpers/class";
// require('../style/btn.less')
require('../style/index.less');
var images = {
    drag: require("../images/drag.png"),
    signature: require("../images/signature.png"),
    date_signed: require("../images/date_signed.png"),
    initials: require("../images/initial.png")
};
var FloatIcon = /** @class */ (function (_super) {
    __extends(FloatIcon, _super);
    function FloatIcon() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FloatIcon.prototype.render = function () {
        var _a = this.props, show = _a.show, pos = _a.pos, selectedFieldType = _a.selectedFieldType;
        return h("div", { class: "floating-icon", style: { display: !show ? "none" : "block", 'top': pos.clientY - 3 + 'px', left: pos.clientX - 3 + 'px' } },
            h("div", { class: "icon" },
                h("img", { src: images[selectedFieldType] })));
    };
    return FloatIcon;
}(Component));
var WebContent = /** @class */ (function (_super) {
    __extends(WebContent, _super);
    function WebContent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WebContent.prototype.shouldComponentUpdate = function () {
        return false;
    };
    WebContent.prototype.render = function () {
        return h("div", { class: "content_main", id: "webpdf_content", style: "position: relative;" });
    };
    return WebContent;
}(Component));
var App = /** @class */ (function (_super) {
    __extends(App, _super);
    function App(props) {
        return _super.call(this, props) || this;
    }
    App.prototype.getChildContext = function () {
        return {
            setSelectedRecipient: this.props.setSelectedRecipient,
            onSelectFieldType: this.onSelectFieldType
        };
    };
    App.prototype.getRecipientColorScheme = function (recipient, opacity) {
        return RecipientColorScheme(this.props.recipients, recipient, opacity);
    };
    App.prototype.isTemplate = function (signInfo) {
        if (signInfo) {
            return signInfo.signType == 2;
        }
        return true;
    };
    App.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, docSignId, accessToken, signInfo, executor, manifestInfo, WebPdf, webpdf, SignPlugin;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this._mounting = true;
                        this._mouseMoveTracker = new DOMMouseMoveTracker(this._onMouseMove, this._onMouseMoveEnd, document.documentElement);
                        _a = this.props, docSignId = _a.docSignId, accessToken = _a.accessToken;
                        return [4 /*yield*/, getSignInfo(docSignId)];
                    case 1:
                        signInfo = _b.sent();
                        this.props.setSignInfo(signInfo);
                        if (this.isTemplate(signInfo)) {
                            this.props.setRecipients(signInfo.signList.map(function (signer) { return Object.assign(signer, { signId: signer.id }); }));
                        }
                        else {
                            this.props.setRecipients(signInfo.signInfo);
                        }
                        executor = new AsyncRetryExecutor({ maxRetry: 10, delay: 1000 });
                        return [4 /*yield*/, executor.getWithRetry(function () {
                                return getDocManifestInfo(signInfo.webPdfDocID);
                            })];
                    case 2:
                        manifestInfo = _b.sent();
                        return [4 /*yield*/, import("../webpdf")];
                    case 3:
                        WebPdf = _b.sent();
                        webpdf = new WebPdf.default();
                        return [4 /*yield*/, import("./SignPlugin")];
                    case 4:
                        SignPlugin = _b.sent();
                        this.signPlugin = new SignPlugin.default(this.context.store, {
                            signing: false,
                            signFieldIcons: images,
                            getRecipientColorScheme: this.getRecipientColorScheme
                        });
                        webpdf.use(this.signPlugin);
                        if (this._mounting) {
                            webpdf.render(this._refWebpdf.base, {
                                manifestInfo: manifestInfo,
                                userInfo: { token: this.props.accessToken },
                                docId: signInfo.webPdfDocID,
                                serverUrl: window.phantomOnlineGlobalConfig.webpdfApiUrl
                            });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    App.prototype.componentWillUnmount = function () {
        this._mounting = false;
    };
    App.prototype._onMouseMove = function (deltaX, deltaY, _a) {
        var clientX = _a.clientX, clientY = _a.clientY;
        this.props.setMousePos({ clientX: clientX, clientY: clientY });
        if (UserAgent.mobile()) {
            var ele = document.elementFromPoint(clientX, clientY);
            if (ele && classHelper.hasClass(ele, "sign_page")) {
                var scrollTop = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
                var event = new CustomEvent("custom_enter", { detail: { clientX: clientX, clientY: clientY + scrollTop } });
                ele.dispatchEvent(event);
            }
        }
    };
    App.prototype._onMouseMoveEnd = function (clientX, clientY) {
        this._mouseMoveTracker.releaseMouseMoves();
        this.props.showFloatIcon(false);
        if (UserAgent.mobile()) {
            var ele = document.elementFromPoint(clientX, clientY);
            if (ele && classHelper.hasClass(ele, "sign_page")) {
                var scrollTop = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
                var event = new CustomEvent("custom_mouseup", { detail: { clientX: clientX, clientY: clientY + scrollTop } });
                ele.dispatchEvent(event);
            }
        }
    };
    App.prototype.onSelectFieldType = function (signFieldType, event) {
        var pos = getEventClientPos(event);
        this.props.setMouseInPage(false);
        this.props.setSelectedFieldType(signFieldType);
        this.props.showFloatIcon(true);
        this.props.setMousePos(pos);
        this._mouseMoveTracker.captureMouseMoves(event);
        event.preventDefault();
    };
    App.prototype.render = function () {
        var _this = this;
        var _a = this.props, bShowFloatIcon = _a.bShowFloatIcon, mousePos = _a.mousePos, inPage = _a.inPage, selectedFieldType = _a.selectedFieldType, recipients = _a.recipients, selectedRecipient = _a.selectedRecipient;
        return (h("div", { class: classNames("site", { "site-fit": !UserAgent.safari(), mobile: UserAgent.mobile(), safari: UserAgent.safari(), android: UserAgent.android() }) },
            h("div", { class: "site_wrap" },
                h("div", { class: "site_header" },
                    h("div", { class: "site_toolbar" },
                        h("div", { class: "toolbar_left recipient-selector" },
                            h(RecipientSelector, null)))),
                h("div", { class: "site_content" },
                    h("div", { class: "content-wrap" },
                        h(WebContent, { ref: function (ref) { return _this._refWebpdf = ref; } })),
                    h(AddFieldsPanel, { images: images, selectedFieldType: selectedFieldType, selectedRecipient: selectedRecipient, recipients: recipients })),
                h(FloatIcon, { selectedFieldType: selectedFieldType, show: bShowFloatIcon && !inPage, pos: mousePos }))));
    };
    __decorate([
        bind
    ], App.prototype, "getRecipientColorScheme", null);
    __decorate([
        bind
    ], App.prototype, "_onMouseMove", null);
    __decorate([
        bind
    ], App.prototype, "_onMouseMoveEnd", null);
    __decorate([
        bind
    ], App.prototype, "onSelectFieldType", null);
    return App;
}(Component));
var mapStateToProps = function (state, ownProps) {
    return {
        accessToken: selector.getToken(state),
        userInfo: selector.getUserInfo(state),
        mousePos: state.sign.mousePos,
        bShowFloatIcon: state.sign.showFloatIcon,
        inPage: state.sign.inPage,
        selectedFieldType: state.sign.selectedFieldType,
        recipients: state.sign.recipients,
        selectedRecipient: state.sign.selectedRecipient || state.sign.recipients[0],
        docSignId: "5bc99c2fdb5bdc0263095561",
    };
};
export default connect(mapStateToProps, actions)(function (props) { return h(App, __assign({}, props)); });
//# sourceMappingURL=add-fields.js.map