var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { h, Component } from "preact";
import AsyncRetryExecutor from "../vendor/AsyncRetryExecutor";
import * as i18next from "i18next";
import { connect } from "preact-redux";
import * as actions from "../actions";
import { SignType } from "../models";
import { getSignInfo, getDocManifestInfo, saveDocSign, getMySign } from "../API";
import { getToken, getUserInfo } from "../selector";
import createDateSignData from "../utils/createDateSignData";
import createDigitalSign from "../utils/createDigitalSign";
import keepRatio from "../utils/keepRatio";
require('../style/index.less');
require('../style/modal.less');
require('../style/btn.less');
var images = {
    drag: require("../images/drag.png"),
    signature: require("../images/signature.png"),
    date_signed: require("../images/date_signed.png"),
    initials: require("../images/initial.png")
};
var WebContent = /** @class */ (function (_super) {
    __extends(WebContent, _super);
    function WebContent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WebContent.prototype.shouldComponentUpdate = function () {
        return false;
    };
    WebContent.prototype.render = function () {
        return h("div", { class: "content_main", id: "webpdf_content", style: "position: relative;" });
    };
    return WebContent;
}(Component));
var Signing = /** @class */ (function (_super) {
    __extends(Signing, _super);
    function Signing(props) {
        return _super.call(this, props) || this;
    }
    Signing.prototype.getRecipientColorScheme = function (recipient, opacity) {
        return {
            backgroundColor: "#006400",
            borderColor: "#006400"
        };
    };
    Signing.prototype.getSignFields = function () {
        var selectedRecipient = this.props.selectedRecipient;
        var signFields = this.signPlugin.getSignFields().toJS();
        return signFields
            .filter(function (signField) { return signField.signed && signField.signerId == selectedRecipient.signerId; })
            .map(function (signField) {
            var size = signField.size, signData = signField.signData;
            var _a = keepRatio(size.width, size.height, signData.width / signData.height), imgWidth = _a.imgWidth, imgHeight = _a.imgHeight;
            return {
                pagenum: signField.pageIndex,
                x: signField.pos.x,
                y: signField.pos.y,
                width: imgWidth,
                height: imgHeight,
                data: signData.dataurl.replace(/data:.*base64,/, ""),
                type: "img"
            };
        });
    };
    Signing.prototype.setSignFields = function (signInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                signInfo.forEach(function (recipient) {
                    recipient.signDetail.forEach(function (signField) {
                        if (signField.type == SignType.date_signed) {
                            var userId = _this.props.userInfo.user_id;
                            var dateSignData = createDateSignData(signField.size.width, signField.size.height);
                            var signData = createDigitalSign(dateSignData, signField.size, userId)
                                .then(function (signData) {
                                Object.assign(signField, { signed: true, signData: signData });
                                _this.signPlugin.addSignField(signField);
                            });
                        }
                        else {
                            _this.signPlugin.addSignField(signField);
                        }
                    });
                });
                return [2 /*return*/];
            });
        });
    };
    Signing.prototype.componentDidMount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var userInfo, signInfo, selectedRecipient, mySigns, executor, manifestInfo, WebPdf, webpdf, SignPlugin;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this._mounting = true;
                        userInfo = this.props.userInfo;
                        console.log("UserInfo", userInfo);
                        return [4 /*yield*/, getSignInfo(this.props.docSignId)];
                    case 1:
                        signInfo = _a.sent();
                        this.props.setRecipients(signInfo.signInfo);
                        selectedRecipient = signInfo.signInfo.find(function (recipient) { return recipient.signStatus == 1; });
                        if (selectedRecipient) {
                            this.props.setSelectedRecipient(selectedRecipient);
                        }
                        else {
                            throw "signInfo invaliate:" + JSON.stringify(signInfo.signInfo);
                        }
                        return [4 /*yield*/, getMySign()];
                    case 2:
                        mySigns = _a.sent();
                        mySigns.forEach(function (mySign) {
                            var signType = mySign.signType == 1 ? SignType.signature : SignType.initials;
                            var signData = { dataurl: mySign.signContent, width: Number(mySign.width), height: Number(mySign.height) };
                            _this.props.setSignData(signType, signData);
                        });
                        executor = new AsyncRetryExecutor({ maxRetry: 10, delay: 1000 });
                        return [4 /*yield*/, executor.getWithRetry(function () {
                                return getDocManifestInfo(signInfo.webPdfDocID);
                            })];
                    case 3:
                        manifestInfo = _a.sent();
                        return [4 /*yield*/, import("../webpdf")];
                    case 4:
                        WebPdf = _a.sent();
                        webpdf = new WebPdf.default();
                        return [4 /*yield*/, import("./SignPlugin")];
                    case 5:
                        SignPlugin = _a.sent();
                        this.signPlugin = new SignPlugin.default(this.context.store, {
                            signing: true,
                            signFieldIcons: images,
                            getRecipientColorScheme: this.getRecipientColorScheme,
                        });
                        // this.signPlugin.setSignDatas = (signType) => {
                        //   showModal(<AddSignatureModal setSign={(type, signData) => {
                        //     uploadMySign(type == SignType.signature ? 1 : 2, signData.dataurl)
                        //     this.props.setSignData(type, signData);
                        //     (signType == type) && this.signPlugin.setSignData(type, signData);
                        //   }
                        //   } fullName={"wenqi_zheng"} initials={"WZ"} />)
                        // }
                        webpdf.use(this.signPlugin);
                        if (this._mounting) {
                            webpdf.render(this._refWebpdf.base, {
                                manifestInfo: manifestInfo,
                                userInfo: { token: this.props.accessToken },
                                docId: signInfo.webPdfDocID,
                                serverUrl: window.phantomOnlineGlobalConfig.webpdfApiUrl
                            });
                        }
                        this.setSignFields(signInfo.signInfo);
                        return [2 /*return*/];
                }
            });
        });
    };
    Signing.prototype.commitSign = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                saveDocSign(this.props.selectedRecipient.signerId, this.getSignFields());
                return [2 /*return*/];
            });
        });
    };
    Signing.prototype.componentWillUnmount = function () {
        this._mounting = false;
    };
    Signing.prototype.render = function () {
        var _this = this;
        var _a = this.props;
        return (h("div", null,
            h("div", { class: "site site-editor site-fit" },
                h("div", { class: "site_wrap" },
                    h("div", { class: "site_header", style: { borderBottom: "1px solid #e6e6e6" } },
                        h("div", { style: { flex: "1 1 0%" } }),
                        h("div", { class: "site_title" },
                            h("div", null, i18next.t("You need to complete {{count}} required fields", { count: 2 }))),
                        h("div", { style: { flex: "1 1 0%" } },
                            h("div", { class: "btn", onClick: function () { return _this.commitSign(); } }, i18next.t("Finish")))),
                    h("div", { class: "site_content" },
                        h("div", { class: "content_wrap" },
                            h(WebContent, { ref: function (ref) { return _this._refWebpdf = ref; } })))))));
    };
    return Signing;
}(Component));
var mapStateToProps = function (state, ownProps) {
    return {
        accessToken: getToken(state),
        docSignId: "5c17593da6104677267cb929",
        recipients: state.sign.recipients,
        selectedRecipient: state.sign.selectedRecipient || state.sign.recipients[0],
        userInfo: getUserInfo(state)
    };
};
export default connect(mapStateToProps, actions)(function (props) { return h(Signing, __assign({}, props)); });
//# sourceMappingURL=signing.js.map