/*-----------------------------------------------------------------*\
    Recipient Colors
\*-----------------------------------------------------------------*/
var colors = [];
(function () {
    colors[0] = {
        backgroundColor: "#ffd65b",
        borderColor: "#f5c431"
    };
    colors[1] = {
        backgroundColor: "#acdce6",
        borderColor: "#81afb8"
    };
    colors[2] = {
        backgroundColor: "#c0a5cf",
        borderColor: "#91789e"
    };
    colors[3] = {
        backgroundColor: "#97c9bf",
        borderColor: "#70948d"
    };
    colors[4] = {
        backgroundColor: "#f7b994",
        borderColor: "#e69d73"
    };
    colors[5] = {
        backgroundColor: "#c3d5e6",
        borderColor: "#6c89a6"
    };
    colors[6] = {
        backgroundColor: "#c0a5cf",
        borderColor: "#aeb86e"
    };
    colors[7] = {
        backgroundColor: "#ff9980",
        borderColor: "#db765c"
    };
    colors[8] = {
        backgroundColor: "#e6c6e6",
        borderColor: "#b38fb3"
    };
    colors[9] = {
        backgroundColor: "#ffb3c6",
        borderColor: "#d98298"
    };
    colors["black"] = {
        backgroundColor: "#333333",
        borderColor: "#333333"
    };
    colors["white"] = {
        backgroundColor: "#ffffff",
        borderColor: "#cccccc"
    };
    colors["navyblue"] = {
        backgroundColor: "#000080",
        borderColor: "#000080"
    };
    colors["brightblue"] = {
        backgroundColor: "#0000ff",
        borderColor: "#0000ff"
    };
    colors["purple"] = {
        backgroundColor: "#800080",
        borderColor: "#800080"
    };
    colors["darkred"] = {
        backgroundColor: "#8b0000",
        borderColor: "#8b0000"
    };
    colors["brightred"] = {
        backgroundColor: "#f00000",
        bordercolor: "#f00000"
    };
    colors["gold"] = {
        backgroundColor: "#ffd700",
        borderColor: "#ffd700"
    };
    colors["green"] = {
        backgroundColor: "#008000",
        borderColor: "#008000"
    };
    colors["darkgreen"] = {
        backgroundColor: "#006400",
        borderColor: "#006400"
    };
})();
export default function recipientColorScheme(recipients, signerId, opacity) {
    if (opacity === void 0) { opacity = 1; }
    var index = recipients.findIndex(function (element) { return element.signerId == signerId; });
    if (index == -1) {
        index = 9;
    }
    var r = (index % 10).toString();
    var color = colors[r];
    if (opacity < 1) {
        return {
            backgroundColor: color.backgroundColor + Math.ceil(opacity * 256).toString(16),
            borderColor: color.borderColor
        };
    }
    return color;
}
//# sourceMappingURL=RecipientColorScheme.js.map