import * as query from "dom-helpers/query";
import clamp from "../vendor/clamp";
import Point from "./point";
export function getPixelsPerPoint() {
    return 1.33;
}
export function adjustPosition(pt, element, boundary, padding) {
    if (padding === void 0) { padding = {}; }
    var offset = query.offset(element);
    var offsetParent = query.offset(boundary);
    var _padding = Object.assign({ top: 0, bottom: 0, left: 0, right: 0 }, padding);
    var x = clamp(pt.x, 0, offsetParent.width - offset.width - _padding.right);
    var y = clamp(pt.y, 0, offsetParent.height - offset.height - _padding.bottom);
    return new Point(x, y);
}
export function getPageElement(pageIndex) {
    return document.getElementById("page" + pageIndex);
}
export function parseColor(value) {
    if (value.length == 8) {
        return "#" + value.substr(2, 6);
    }
    else {
        return "#" + value;
    }
}
//# sourceMappingURL=common.js.map