import imageComplete from "./imgComplete";
export default function (signData, size, userId) {
    return new Promise(function (resolve) {
        var canvass = document.createElement('canvas');
        var leftRightWidth = 4;
        var width = size.width * 3;
        var height = size.height * 3;
        canvass.width = width;
        canvass.height = height;
        document.body.appendChild(canvass);
        var ctx = canvass.getContext('2d');
        ctx.clearRect(0, 0, canvass.width, canvass.height);
        var img = new Image();
        imageComplete(img, function (img) {
            var left = 30;
            var top = 25;
            var img_maxWidth = width - left;
            var img_maxHeight = height - top * 2;
            var scale = Math.min(img_maxWidth / signData.width, img_maxHeight / signData.height);
            var img_width = signData.width * scale;
            var img_height = signData.height * scale;
            ctx.drawImage(img, left, top, img_width, img_height);
            var padding_left = 20;
            var padding_top = 20;
            var padding_bottom = 20;
            ctx.strokeStyle = "#2c6ee1";
            ctx.lineWidth = 4 * height / 200;
            ctx.beginPath();
            ctx.moveTo(40, padding_top / 2);
            ctx.lineTo(padding_left * 1.5, padding_top / 2);
            ctx.quadraticCurveTo(2, padding_top / 2, 2, padding_top * 1.5);
            ctx.lineTo(2, height - padding_bottom * 1.5);
            ctx.quadraticCurveTo(2, height - padding_bottom / 2, padding_left * 1.5, height - padding_bottom / 2);
            ctx.lineTo(40, height - padding_bottom / 2);
            ctx.stroke();
            var fontsize = 20;
            ctx.font = "bold " + fontsize + "px proxima nova-light";
            ctx.fillStyle = "#000000";
            ctx.fillText("cSigned by:", 40, padding_top / 2 + fontsize / 4);
            ctx.fillText(userId, 40, height - padding_bottom / 2 + fontsize / 4);
            resolve({ "dataurl": canvass.toDataURL("image/png"), width: width, height: height });
            canvass.parentNode.removeChild(canvass);
        });
        img.src = signData.dataurl;
    });
}
//# sourceMappingURL=createDigitalSign.js.map