import Spring from "../vendor/Spring";
var AnimateExecutor = /** @class */ (function () {
    function AnimateExecutor(options) {
        if (options === void 0) { options = {}; }
        this._options = Object.assign({ velocity: 2000, tension: 300, friction: 30 }, options);
    }
    AnimateExecutor.prototype.execute = function (distance, progressCB, finishedCB) {
        var _this = this;
        if (this._spring && this._spring.moving)
            return;
        this._spring = new Spring(this._options);
        var step = function () {
            _this._animationFrameID = null;
            var p = _this._spring.step();
            progressCB.call(null, p * distance / 100);
            if (_this._spring.moving) {
                _this._animationFrameID = window.requestAnimationFrame(step);
            }
            else {
                finishedCB && finishedCB.apply(null);
            }
        };
        if (this._animationFrameID == null) {
            step();
        }
    };
    return AnimateExecutor;
}());
export default AnimateExecutor;
//# sourceMappingURL=AnimateExecutor.js.map