/**
 * Copyright (c) 2015, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * @providesModule BrowserSupportCore
 */
import getVendorPrefixedName from './getVendorPrefixedName';
var BrowserSupportCore = {
    /**
     * @return {bool} True if browser supports css animations.
     */
    hasCSSAnimations: function () {
        return !!getVendorPrefixedName('animationName');
    },
    /**
     * @return {bool} True if browser supports css transforms.
     */
    hasCSSTransforms: function () {
        return !!getVendorPrefixedName('transform');
    },
    /**
     * @return {bool} True if browser supports css 3d transforms.
     */
    hasCSS3DTransforms: function () {
        return !!getVendorPrefixedName('perspective');
    },
    /**
     * @return {bool} True if browser supports css transitions.
     */
    hasCSSTransitions: function () {
        return !!getVendorPrefixedName('transition');
    },
};
export default BrowserSupportCore;
//# sourceMappingURL=BrowserSupportCore.js.map