var Rect = /** @class */ (function () {
    function Rect(_a) {
        var left = _a.left, top = _a.top, width = _a.width, height = _a.height;
        this.left = left;
        this.top = top;
        this.width = width;
        this.height = height;
    }
    Rect.prototype.resize = function (w, h) {
        this.width = w;
        this.height = h;
    };
    ;
    Rect.prototype.centerScale = function (_scale) {
        return new Rect({
            top: this.top - (this.height * (_scale - 1)) / 2,
            left: this.left - (this.width * (_scale - 1)) / 2,
            width: this.width * _scale,
            height: this.height * _scale
        });
    };
    ;
    Rect.prototype.scale = function (_scale) {
        return new Rect({
            top: this.top * _scale,
            left: this.left * _scale,
            width: this.width * _scale,
            height: this.height * _scale
        });
    };
    // --- collisions ---
    Rect.prototype.collides = function (rect) {
        if (this.width + this.height == 0)
            return false;
        if (rect.width + rect.height == 0)
            return false;
        return !(this.top > rect.bottom ||
            this.right < rect.left ||
            this.bottom < rect.top ||
            this.left > rect.right);
    };
    ;
    Rect.prototype.overlap = function (rect) {
        if (!this.collides(rect))
            return Rect.emptyRect;
        return Rect.aabb(Math.max(this.left, rect.left), Math.max(this.top, rect.top), Math.min(this.right, rect.right), Math.min(this.bottom, rect.bottom));
    };
    Rect.prototype.offset = function (x, y) {
        if (this === Rect.emptyRect) {
            return this;
        }
        return new Rect({ top: this.top - y, left: this.left - x, width: this.width, height: this.height });
    };
    Rect.prototype.contains = function (pt) {
        return pt.x >= this.left && pt.x <= this.right && pt.y >= this.top && pt.y <= this.bottom;
    };
    Object.defineProperty(Rect.prototype, "right", {
        get: function () {
            return this.left + this.width;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Rect.prototype, "bottom", {
        get: function () {
            return this.top + this.height;
        },
        enumerable: true,
        configurable: true
    });
    Rect.aabb = function (x1, y1, x2, y2) {
        return new Rect({ top: y1, left: x1, width: x2 - x1, height: y2 - y1 });
    };
    ;
    Rect.emptyRect = new Rect({ top: 0, left: 0, width: 0, height: 0 });
    return Rect;
}());
export default Rect;
//# sourceMappingURL=Rect.js.map