function getNativeEvent(event) {
    while (event && typeof event.originalEvent !== "undefined") {
        event = event.originalEvent;
    }
    return event;
}
function getEventClientPos(event) {
    var x = event.clientX;
    var y = event.clientY;
    if (event.type == "touchmove" || event.type == "touchend" || event.type == "touchstart") {
        var touch = getNativeEvent(event).touches[0];
        return {
            clientX: touch.clientX,
            clientY: touch.clientY
        };
    }
    if (event.type == "mousedown" ||
        event.type == "mousemove" ||
        event.type == "mouseup" ||
        event.type == "mouseenter" ||
        event.type == "mouseleave") {
        return {
            clientX: event.clientX,
            clientY: event.clientY
        };
    }
    throw "invalidate event type:" + event.type;
}
export default getEventClientPos;
//# sourceMappingURL=getPtClientPos.js.map