var __DEBUG__;
var displayBuffer;
var colors = {
    prevState: '#9E9E9E',
    action: '#03A9F4',
    nextState: '#4CAF50'
};
/* istanbul ignore next: debug messaging is not tested */
function initBuffer() {
    displayBuffer = {
        header: [],
        prev: [],
        action: [],
        next: [],
        msgs: []
    };
}
/* istanbul ignore next: debug messaging is not tested */
function printBuffer() {
    var header = displayBuffer.header, prev = displayBuffer.prev, next = displayBuffer.next, action = displayBuffer.action, msgs = displayBuffer.msgs;
    if (console.group) {
        console.groupCollapsed.apply(console, header);
        console.log.apply(console, prev);
        console.log.apply(console, action);
        console.log.apply(console, next);
        console.log.apply(console, msgs);
        console.groupEnd();
    }
    else {
        console.log.apply(console, header);
        console.log.apply(console, prev);
        console.log.apply(console, action);
        console.log.apply(console, next);
        console.log.apply(console, msgs);
    }
}
/* istanbul ignore next: debug messaging is not tested */
function colorFormat(text, color, obj) {
    return [
        "%c" + text,
        "color: " + color + "; font-weight: bold",
        obj
    ];
}
/* istanbul ignore next: debug messaging is not tested */
function start(action, state) {
    initBuffer();
    if (__DEBUG__) {
        if (console.group) {
            displayBuffer.header = ['%credux-undo', 'font-style: italic', 'action', action.type];
            displayBuffer.action = colorFormat('action', colors.action, action);
            displayBuffer.prev = colorFormat('prev history', colors.prevState, state);
        }
        else {
            displayBuffer.header = ['redux-undo action', action.type];
            displayBuffer.action = ['action', action];
            displayBuffer.prev = ['prev history', state];
        }
    }
}
/* istanbul ignore next: debug messaging is not tested */
function end(nextState) {
    if (__DEBUG__) {
        if (console.group) {
            displayBuffer.next = colorFormat('next history', colors.nextState, nextState);
        }
        else {
            displayBuffer.next = ['next history', nextState];
        }
        printBuffer();
    }
}
/* istanbul ignore next: debug messaging is not tested */
function log() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    if (__DEBUG__) {
        displayBuffer.msgs = displayBuffer.msgs
            .concat(args.concat(['\n']));
    }
}
/* istanbul ignore next: debug messaging is not tested */
function set(debug) {
    __DEBUG__ = debug;
}
export { set, start, end, log };
//# sourceMappingURL=debug.js.map