import { dpi, dpr } from './browser';
import { pageMatrix } from './matrix';
var pxValueArr = [dpi.x, dpi.y];
var ptValue = 72;
function pt2px(pt, xOry) {
    if (xOry === void 0) { xOry = 0; }
    return pt * pxValueArr[xOry] / ptValue;
}
function px2pt(px, xOry) {
    if (xOry === void 0) { xOry = 0; }
    return px * ptValue / pxValueArr[xOry];
}
function multiDPR(value) {
    return value * dpr;
}
function ptDPRpx(value, xOry) {
    if (xOry === void 0) { xOry = 0; }
    return dpr * value * pxValueArr[xOry] / ptValue;
}
function pxDPRpt(value, xOry) {
    if (xOry === void 0) { xOry = 0; }
    return value / dpr / pxValueArr[xOry] * ptValue;
}
function getWHByMatrix(width, height, scale, rotate) {
    if (scale === void 0) { scale = 1; }
    if (rotate === void 0) { rotate = 0; }
    var matrix = pageMatrix(width, height, scale, rotate);
    return [
        matrix[3] * width + matrix[5],
        matrix[3] * height + matrix[5],
    ];
}
function getSmartScale(scale, minScale, maxScale) {
    return Math.min(Math.max(Math.ceil(scale * 4) / 4, minScale), maxScale);
}
export { pt2px, px2pt, multiDPR, ptDPRpx, pxDPRpt, getWHByMatrix, getSmartScale, };
//# sourceMappingURL=transform.js.map