var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { h, render } from "preact";
import App from "../components/App";
import Provider from 'preact-context-provider';
import createStore from './store';
import { EventEmitter } from "events";
var WebPdf = /** @class */ (function (_super) {
    __extends(WebPdf, _super);
    function WebPdf() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._plugins = [];
        return _this;
    }
    WebPdf.prototype.render = function (element, options) {
        this._store = createStore(options, this._plugins);
        var root;
        root = render(h(Provider, { store: this._store, plugins: this._plugins, webpdf: this },
            h(App, null)), element, root);
    };
    WebPdf.prototype.use = function (plugin) {
        plugin.webpdf = this;
        this._plugins.push(plugin);
    };
    WebPdf.prototype.getStore = function () {
        return this._store;
    };
    WebPdf.prototype.getState = function () {
        return this._store.getState();
    };
    return WebPdf;
}(EventEmitter));
export default WebPdf;
//# sourceMappingURL=webpdf.js.map